
/**
 * A module defining `ModbusDeviceConfigView`.
 *
 * @module nmodule/honIrmControl/rc/ModbusDeviceConfigView
 */
define(['baja!',
	    'baja!honIrmControl:ModbusDevice',
	    'baja!honIrmControl:ModbusServerSideCallHandler',
	    'baja!honIrmControl:ModbusDeviceArgs',
	    'baja!honIrmControl:ModbusReadPoint',
	    'baja!honIrmControl:ModbusReadPointDisplayArgs',
	    'baja!honIrmControl:ModbusWritePoint',
	    'baja!honIrmControl:ModbusWritePointDisplayArgs',
        'bajaux/mixin/subscriberMixIn',
        'bajaux/util/SaveCommand',
        'bajaux/Widget',
        'css!nmodule/honIrmControl/rc/css/irmnx-styles',
        'css!nmodule/honIrmControl/rc/css/comp-table',
        'hbs!nmodule/honIrmControl/rc/templates/modbusDeviceView',
        'hbs!nmodule/honIrmControl/rc/templates/modbusReadPointDialog',
        'hbs!nmodule/honIrmControl/rc/templates/modbusWritePointDialog',
        'nmodule/honIrmControl/rc/ModbusReadPointsConfig',
        'nmodule/honIrmControl/rc/ModbusWritePointsConfig',
        'nmodule/honIrmControl/rc/ModbusUtil',
        'jquery',
        'dialogs',
        'lex!honIrmControl', 
        'Promise'], function ( 
        baja,
        ModbusDevice,
        ModbusServerSideCallHandler,
        ModbusDeviceArgs,
        ModbusReadPoint,
        ModbusReadPointDisplayArgs,
        ModbusWritePoint,
        ModbusWritePointDisplayArgs,
        subscriberMixIn,
        SaveCommand,
        Widget,
        css,
        tablecss,
        template,
        templateReadPointDialog,
        modbusWritePointDialog,
        ModbusReadPointsConfig,
        ModbusWritePointsConfig,
        ModbusUtil,
        $,
        dialogs,
        lexicons, //---------------------------------------------------------- *NEW*
        Promise) {

  'use strict';
  
  
  
    var honIrmControlLex = lexicons[0];
 
    var modbusReadPointsConfig = new ModbusReadPointsConfig();
    var modbusUtil = new ModbusUtil();
    var modbusWritePointsConfig = new ModbusWritePointsConfig();
  
    var deviceAddress = "DeviceAddress",
    byteOrder = "ByteOrder",
    maxReadPointsCount = "MaxReadPointCount",
    readPtOperationMode ="readPtOperationMode";
   

    
	function getModBusDeviceName() {									
		return $('#deviceNameLabelId');
	}
    
	function getModBusDeviceAddress() {									
		return  $('#devAddressId');
	}
	
	function getModBusDeviceByteOrder() {		
		return $('#byteOrderId');
	}
	
	function getModBusDevicePointCount() {		
		return $('#maxReadPointsCountId');
	}
	
	function setModBusDeviceReadWritePointCount(isRead,count) {		
		if(isRead == true){
			$('#readPointCountId').text(count);
		}else{
			$('#writePointCountId').text(count);
		}
	}

	//dialog read points-------------------
	function getReadPointTypeOnDialogId(dom) {									
		return dom.find('#readPointTypeDialogId');
	}
    
	function getOperationModeDialogId(dom) {									
		return dom.find('#readPointOperationModeDialogId');
	}
	
	function getDataFormatDialogId(dom) {		
		return dom.find('#dataFormatDialogId');
	}
	
	function getScalingFactorDialogId(dom) {		
		return dom.find('#scalingFactorDialogId');
	}
	
	function getReadPointAddressDialogId(dom) {		
		return dom.find('#readPointAddressDialogId');
	}
	
	function getReadPointNameDialogId(dom) {		
		return dom.find('#readPointNameDialogId');
	}
	
	function getReadPointEventBitMaskingDialogId(dom) {		
		return dom.find('#eventBitMaskingDialogId');
	}
	
	//dialog write points-------------------
	function getWritePointTypeOnDialogId(dom) {									
		return dom.find('#writePointTypeDialogId');
	}
	function getWritePointDataFormatDialogId(dom) {		
		return dom.find('#writePointDataFormatDialogId');
	}
	
	function getSignificantChangeDialogId(dom) {		
		return dom.find('#significantChangeDialogId');
	}
	
	function getWritePointAddressDialogId(dom) {		
		return dom.find('#writePointAddressDialogId');
	}
	
	function getWritePointNameDialogId(dom) {		
		return dom.find('#writePointNameDialogId');
	}
	
	function getReadPointTableFromDocument() {		
		return document.getElementById("readPointTableBodyId");
	}
	
	function getWritePointTableFromDocument() {		
		return document.getElementById("writePointTableBodyId");
	}
	
	function getReadPtPollTimeDialogId(dom) {		
		return dom.find('#readPointPollTimeDialogId');
	}
	
	function getReadPtPollTimeLabelId(dom) {									
		return dom.find('#readPointPollTimeLabelId');
	}
	function getReadPtPollTimeRangeLabelId(dom) {	
		return dom.find('#readPointPollTimeRangeLabelId');	
	}
		
	function loadModBusByteOrderInView(modbusDevByteOrderDom,modbusDevicePropResult) {
		var modbusDeviceObj = baja.$('honIrmControl:ModbusDevice');
		var byteOrderArrOrdinal = modbusDeviceObj.getByteOrder().$map.$map.valueFacets.$val.get("range").getOrdinals();
		var option = '';
		for (var i=0;i<byteOrderArrOrdinal.length;i++){
			var optionByteOrderVal =  modbusDeviceObj.getByteOrder().$map.$map.valueFacets.$val.get("range").getTag(byteOrderArrOrdinal[i]);
			option += '<option value="'+ byteOrderArrOrdinal[i] + '">' + optionByteOrderVal + '</option>';
		}
		modbusDevByteOrderDom.append(option);
		modbusDevByteOrderDom.val(modbusDevicePropResult.get(byteOrder).$ordinal.toString());
	}
	
	
	function loadModBusPointCountInView(modbusDevReadPointCountDom,modbusDevicePropResult) {									
		modbusDevReadPointCountDom.val(modbusDevicePropResult.get(maxReadPointsCount).$val);
	}
	
	function loadModBusModBusDeviceAddressInView(modbusDevAddressDom,modbusDevicePropResult) {									
		modbusDevAddressDom.val(modbusDevicePropResult.get(deviceAddress).$val);
	}

	
  /**
	 * Description of your widget.
	 * 
	 * @class
	 * @extends module:nmodule/webEditors/rc/fe/baja/BaseEditor
	 * @alias module:nmodule/honIrmControl/rc/ModbusDeviceConfigView
	 */
	var ModbusDeviceConfigView = function () {
	      Widget.apply(this, arguments);
	      subscriberMixIn(this);
	      this.readPointDataList = {};
	      this.writePointDataList = {};
	      //list contains the points that will be deleted from stations
	      this.deleteReadPointDataList = {};
	      this.deleteWritePointDataList = {};
	    // Add a Save Command to allow the user to save the `Widget`.
	    this.getCommandGroup().add(new SaveCommand());
	    this.readPtOperationModeOrdinals;
	    this.readPtOperationModeRange;
	  };
	  ModbusDeviceConfigView.prototype = Object.create(Widget.prototype);
	  ModbusDeviceConfigView.prototype.constructor = ModbusDeviceConfigView;
	  
	  ModbusDeviceConfigView.prototype.tabHandler = function (evt, tabName) {
		  var i, tabcontent, tabModbusBtn;
		  tabcontent = document.getElementsByClassName("tabcontent");
		  for (i = 0; i < tabcontent.length; i++) {
			tabcontent[i].style.display = "none";
		  }
		  tabModbusBtn = document.getElementsByClassName("tablinks");
		  for (i = 0; i < tabModbusBtn.length; i++) {
			  if(tabModbusBtn[i].className != evt.currentTarget.className){
			  tabModbusBtn[i].className = tabModbusBtn[i].className.replace(" active", " Inactive");
			  }else{
				  tabModbusBtn[i].className = tabModbusBtn[i].className.replace(" active", "");
				  tabModbusBtn[i].className = tabModbusBtn[i].className.replace(" Inactive", "");
			  }
			  
		  }
		  document.getElementById(tabName).style.display = "block";
		  evt.currentTarget.className += " active";			  
		};
	  
	  ModbusDeviceConfigView.prototype.attachTabEvents = function(dom) {
           var that = this;
           dom.find("div.button-cover").on('click', 'button',
               function(event){
                   try{
                	   var tabName = $(event.target).attr("data-tabname");                	   
                       that.tabHandler(event, tabName);
                       event.preventDefault();
                   }catch(error){
                       //Baja.error(error);
                       event.preventDefault();
                   }
               });         
       };
	  

  /**
   * Describe how your widget does its initial setup of the DOM.
   *
   * @param {jQuery} element the DOM element into which to load this widget
   */
  ModbusDeviceConfigView.prototype.doInitialize = function (dom) {
	  var widget = this;
	    // The template function returns the contents of modbusDeviceView.hbs, but with
	    // variables like {{value}} filled in using the properties of the object
	    // argument.
	    dom.html(template({ //------------------------------------------------ *NEW*
	      deviceNameLabel: honIrmControlLex.get('honIrmControlLex.deviceName.label'),
	      DeviceAddress: honIrmControlLex.get('honIrmControlLex.deviceAddress.label'),
	      ByteOrder: honIrmControlLex.get('honIrmControlLex.byteOrder.label'),
	      MaxReadPointsCount: honIrmControlLex.get('honIrmControlLex.maxReadPointsCount.label'),
	      MaxReadPointsCountRange: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.range'),
	      DeviceAddressRange: honIrmControlLex.get('honIrmControlLex.modbus.device.address.range'),
	      //colum name read pt
	      ReadPointsCount: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.count'),	
	      ReadPointName: honIrmControlLex.get('honIrmControlLex.readpoint.name.label'),
	      ReadPointType: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointType.label'),
	      ReadPointAddress: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointAddress.label'),
	      ReadPointOperationMode: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointOperationMode.label'),
	      ReadPointPollTime: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.label'),
	      ScalingFactor: honIrmControlLex.get('honIrmControlLex.readpoint.ScalingFactor.label'),
	      ReadDataFormat: honIrmControlLex.get('honIrmControlLex.readpoint.DataFormat.label'),
	      EventBitMasking: honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label'),
	      //colum name write pt
	      WritePointsCount: honIrmControlLex.get('honIrmControlLex.modbus.device.writePoint.count'),	
	      WritePointName: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointName.label'),
	      WritePointType: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointType.label'),
	      WritePointAddress: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointAddress.label'),
	      SignificantChange: honIrmControlLex.get('honIrmControlLex.writepoint.SignificantChange.label'),
	      WriteDataFormat: honIrmControlLex.get('honIrmControlLex.writepoint.WriteDataFormat.label'),
	      
	      
	    }));

	    // When the user makes a change, mark the `Widget` as modified using
	    // setModified(true).
	    dom.on('input', '.form-element', function () {
	      widget.setModified(true);
	    }); 
	    dom.on('select', '.form-element', function () {
		      widget.setModified(true);
		    });
	    widget.attachTabEvents(dom);
	    $("#pointReadTabId").css('display', 'block');
	    $("#pointWriteTabId").css('display', 'none');
		   
  };

  /**
   * Describe how your widget loads in a value.
   *
   * @param value description of the value to be loaded into this widget
   */
  ModbusDeviceConfigView.prototype.doLoad = function (modbusDevice) {
	  var widget = this;
	  var dom = widget.jq();
	  createModbusOverviewContent(modbusDevice, widget);
	  loadModbusReadPointsContent(modbusDevice, widget);
	  loadModbusWritePointsContent(modbusDevice, widget);
	  //capturing events on add and delete of readPoints ,write points
	  addModbusReadPointDialog(widget);
	  addModbusWritePointDialog(widget);
	  deleteModbusReadPoints(widget);
	  deleteModbusWritePoints(widget);
	  
	  
	  var param = {
		    	mainView:widget
	   };	
	  dom.on("change", ModbusReadPointsConfig.selectAllReadPtIdChkBox,param,function(event){
	     event.preventDefault();
	     modbusReadPointsConfig.selectAllCheckBoxFromReadPointsTable(event.data.mainView);
	  }); 
	  dom.on("change", ModbusWritePointsConfig.selectAllWritePtIdChkBox,param,function(event){
		 event.preventDefault();
		 modbusWritePointsConfig.selectAllCheckBoxFromWritePointsTable(event.data.mainView);
	  }); 
	  
	  dom.on("click", "#readPtAddressCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtNameIconId",event.data.mainView);  //sortReadPtNameIconId  sortReadPtAddressIconId
		     clearFilterIcon("#sortReadPtTypeIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtOperationModeIconId",event.data.mainView);
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtAddressFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtAddressFilterAsc;
		    	 applyFilterIcon("#sortReadPtAddressIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtAddressFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtAddressFilterDsc;
		    	 applyFilterIcon("#sortReadPtAddressIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtAddressFilterAsc;
		    	 applyFilterIcon("#sortReadPtAddressIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		}); 
	  
	  dom.on("click", "#readPtNameCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtTypeIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtOperationModeIconId",event.data.mainView);
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtNameFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtNameFilterAsc;
		    	 applyFilterIcon("#sortReadPtNameIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtNameFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtNameFilterDsc;
		    	 applyFilterIcon("#sortReadPtNameIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtNameFilterAsc;
		    	 applyFilterIcon("#sortReadPtNameIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		});
	  
	  dom.on("click", "#readPtTypeCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtNameIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtOperationModeIconId",event.data.mainView);
		     
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtTypeFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtTypeFilterAsc;
		    	 applyFilterIcon("#sortReadPtTypeIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtTypeFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtTypeFilterDsc;
		    	 applyFilterIcon("#sortReadPtTypeIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtTypeFilterAsc;
		    	 applyFilterIcon("#sortReadPtTypeIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		});
	  
	  
	  dom.on("click", "#readPtOperationModeCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtTypeIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtNameIconId",event.data.mainView);
		     
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtOperationModeFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtOperationModeFilterAsc;
		    	 applyFilterIcon("#sortReadPtOperationModeIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtOperationModeFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtOperationModeFilterDsc;
		    	 applyFilterIcon("#sortReadPtOperationModeIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtOperationModeFilterAsc;
		    	 applyFilterIcon("#sortReadPtOperationModeIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		});
	  
	  
	  
	  dom.on("click", "#writePtAddressCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortWritePtNameIconId",event.data.mainView);  //sortReadPtNameIconId  sortReadPtAddressIconId
		     //sortReadPtNameIconId  sortReadPtAddressIconId
		     clearFilterIcon("#sortWritePtTypeIconId",event.data.mainView); 
		     if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtAddressFilterDsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtAddressFilterAsc;
		    	 applyFilterIcon("#sortWritePtAddressIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtAddressFilterAsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtAddressFilterDsc;
		    	 applyFilterIcon("#sortWritePtAddressIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtAddressFilterAsc;
		    	 applyFilterIcon("#sortWritePtAddressIconId","Asc",event.data.mainView);
		     }
		     modbusWritePointsConfig.sortWriteTableOnSelectedFilter(event.data.mainView,ModbusWritePointsConfig.activeFilterWritePts);

		}); 
	  
	  dom.on("click", "#writePtNameCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortWritePtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortWritePtTypeIconId",event.data.mainView); 
		     if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtNameFilterDsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtNameFilterAsc;
		    	 applyFilterIcon("#sortWritePtNameIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtNameFilterAsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtNameFilterDsc;
		    	 applyFilterIcon("#sortWritePtNameIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtNameFilterAsc;
		    	 applyFilterIcon("#sortWritePtNameIconId","Asc",event.data.mainView);
		     }
		     modbusWritePointsConfig.sortWriteTableOnSelectedFilter(event.data.mainView,ModbusWritePointsConfig.activeFilterWritePts);

		}); 
	  
	  dom.on("click", "#writePtTypeCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortWritePtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortWritePtNameIconId",event.data.mainView); 
		     if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtTypeFilterDsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtTypeFilterAsc;
		    	 applyFilterIcon("#sortWritePtTypeIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtTypeFilterAsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtTypeFilterDsc;
		    	 applyFilterIcon("#sortWritePtTypeIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtTypeFilterAsc;
		    	 applyFilterIcon("#sortWritePtTypeIconId","Asc",event.data.mainView);
		     }
		     modbusWritePointsConfig.sortWriteTableOnSelectedFilter(event.data.mainView,ModbusWritePointsConfig.activeFilterWritePts);

		}); 

  };
  
   function applyFilterIcon(id,sortType,widget)
   {
	   var dom = widget.jq();
	   
	   if(sortType === "Asc")
	   {
		   dom.find(id).html("&#9650;");
	   }
	   else if(sortType === "Dsc")
	   {
	      dom.find(id).html("&#9660;");
	   }	   
   }
   
   function clearFilterIcon(id,widget)
   {
	   var dom = widget.jq();
	   dom.find(id).text("");	   
   }
  
  
  function deleteModbusReadPoints(widget){  
	   var dom = widget.jq();
	    var param = {
		    	mainView:widget
		     };	    
	    dom.on('click', "#deleteButtonReadPointId",
	    		 param,
	    		 function (event) 
	          {      	
	    	   event.preventDefault();
	    	   var mainView = event.data.mainView;
	    	   deleteSelectedReadPointsFromTableAndShowWarning(mainView);
			  });	  
     }
   
  function deleteSelectedReadPointsFromTableAndShowWarning(widget){
	  // If select all button is checked
      var dom = widget.jq()
	  var readPointTableBody = modbusReadPointsConfig.getReadPointTableId(dom);
	  var readPointRows = readPointTableBody.find(".md-table-row");
	  var totalNoOfReadPts = readPointRows.length;
	  var objReadPointValues = Object.assign({},readPointRows);
	  var anyChkBoxNotSelected = true;
	  
	  if($("#selecetAllReadPtIdChkBox").prop("checked") == true){
		  if(totalNoOfReadPts > 0){
	             showDeleteWarningDialogAndPtsTobeDeleted(true,widget);
	             anyChkBoxNotSelected = false;  
		   }
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfReadPts; j++) {
				  var readPointRowId = objReadPointValues[j].getAttribute("id");
		    	  var count= readPointRowId.substring(ModbusUtil.seventeenNumber),
		    	  count = Number(count);
				  var readPointTableCheckRowId = ModbusReadPointsConfig.checkBoxReadPoint+count;
				  var readPointTableRowId = "#"+readPointRowId;
				  if($(readPointTableCheckRowId).prop("checked") == true){
					 showDeleteWarningDialogAndPtsTobeDeleted(true,widget);
					 anyChkBoxNotSelected = false;
					 break;
				  }
			  }	
		  }
	  if(anyChkBoxNotSelected == true){
		  modbusUtil.showWarningDialogAndPtsTobeDeleted(true);
	  }
	 }	
  
  
  function deleteSelectedReadPointsFromTable(widget){
	  // If select all button is checked
      var dom = widget.jq()
	  var readPointTableBody = modbusReadPointsConfig.getReadPointTableId(dom);
	  var readPointRows = readPointTableBody.find(".md-table-row");
	  var totalNoOfReadPts = readPointRows.length;
	  var objReadPointValues = Object.assign({},readPointRows);
	  if($("#selecetAllReadPtIdChkBox").prop("checked") == true){		  
		  for (var i = 0; i <totalNoOfReadPts; i++) {
			  var readPointRowId = objReadPointValues[i].getAttribute("id");
			  var readPointTableRowId = "#"+readPointRowId;
			  $( readPointTableRowId).remove();
			  widget.setModified(true);
		    }
		  //before deleting put the item in deleted list if OldFb is true
		  for (var key in  widget.readPointDataList) {
		   if(widget.readPointDataList[key].oldFb == true){
			  widget.deleteReadPointDataList[key] = widget.readPointDataList[key];
		    }
		  }
		  widget.readPointDataList = {};
		  //once the delete action is done then we should de select the selectAll checkbox
		  $("#selecetAllReadPtIdChkBox").prop("checked",false);
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfReadPts; j++) {
				  var readPointRowId = objReadPointValues[j].getAttribute("id");
		    	  var count= readPointRowId.substring(ModbusUtil.seventeenNumber),
		    	  count = Number(count);
				  var readPointTableCheckRowId = ModbusReadPointsConfig.checkBoxReadPoint+count;
				  var readPointTableRowId = "#"+readPointRowId;
				  if($(readPointTableCheckRowId).prop("checked") == true){
					  var deleteChkBoxId = "checkBoxReadPoint"+count;
					  //before deleting put the item in deleted list if OldFb is true
					  if(widget.readPointDataList[deleteChkBoxId].oldFb == true){
						  widget.deleteReadPointDataList[deleteChkBoxId] = widget.readPointDataList[deleteChkBoxId];
					  }
					  delete widget.readPointDataList[deleteChkBoxId]; 
					  
					  $( readPointTableRowId).remove();
					  widget.setModified(true);
				  }
			  }	
		  }
	  setModBusDeviceReadWritePointCount(true,Object.keys(widget.readPointDataList).length);
	 }	
  
  function deleteModbusWritePoints(widget){  
	   var dom = widget.jq();
	    var param = {
		    	mainView:widget
		     };	    
	    dom.on('click', "#deleteButtonWritePointId",
	    		 param,
	    		 function (event) 
	          {      	
	    	   event.preventDefault();
	    	   var mainView = event.data.mainView;
	    	   deleteSelectedWritePointsFromTableAndShowWarning(mainView);
		});	  
    }
  
 function deleteSelectedWritePointsFromTable(widget){
	  // If select all button is checked
     var dom = widget.jq()
	  var writePointTableBody = modbusWritePointsConfig.getWritePointTableId(dom);
	  var writePointRows = writePointTableBody.find(".md-table-row");
	  var totalNoOfWritePts = writePointRows.length;
	  var objWritePointValues = Object.assign({},writePointRows);
	  if($("#selecetAllWritePtIdChkBox").prop("checked") == true){		  
		  for (var i = 0; i <totalNoOfWritePts; i++) {
			  var writePointRowId = objWritePointValues[i].getAttribute("id");
			  var writePointTableRowId = "#"+writePointRowId;
			  $( writePointTableRowId).remove();
			  widget.setModified(true);
		    }
		  //before deleting put the item in deleted list if OldFb is true and it will be sent to serverside call
		  for (var key in  widget.writePointDataList) {
		     if(widget.writePointDataList[key].oldFb == true) {
			    widget.deleteWritePointDataList[key] = widget.writePointDataList[key];
		     }
		   }
		  widget.writePointDataList = {};
		  //once the delete action is done then we should de select the selectAll checkbox
		  $("#selecetAllWritePtIdChkBox").prop("checked",false);
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfWritePts; j++) {
				  var writePointRowId = objWritePointValues[j].getAttribute("id");
		    	  var count= writePointRowId.substring(ModbusUtil.eighteenNumber),
		    	  count = Number(count);
				  var writePointTableCheckRowId = ModbusWritePointsConfig.checkBoxWritePoint+count;
				  var writePointTableRowId = "#"+writePointRowId;
				  if($(writePointTableCheckRowId).prop("checked") == true){
					  var deleteChkBoxId = "checkBoxWritePoint"+count;
					  //before deleting put the item in deleted list if OldFb is true and it will be sent to serverside call
					  if(widget.writePointDataList[deleteChkBoxId].oldFb == true){
						  widget.deleteWritePointDataList[deleteChkBoxId] = widget.writePointDataList[deleteChkBoxId];
					  }
					  delete widget.writePointDataList[deleteChkBoxId]; 
					  $( writePointTableRowId).remove();
					  widget.setModified(true);
				  }
			  }	
		  }
	  setModBusDeviceReadWritePointCount(false,Object.keys(widget.writePointDataList).length);
	  
	 }
 
 function deleteSelectedWritePointsFromTableAndShowWarning(widget){
	  // If select all button is checked
    var dom = widget.jq()
	  var writePointTableBody = modbusWritePointsConfig.getWritePointTableId(dom);
	  var writePointRows = writePointTableBody.find(".md-table-row");
	  var totalNoOfWritePts = writePointRows.length;
	  var objWritePointValues = Object.assign({},writePointRows);
	  var anyChkBoxNotSelected = true;
	  if($("#selecetAllWritePtIdChkBox").prop("checked") == true){
		  if(totalNoOfWritePts > 0){
				 showDeleteWarningDialogAndPtsTobeDeleted(false,widget);
				 anyChkBoxNotSelected = false;  
		   }
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfWritePts; j++) {
				  var writePointRowId = objWritePointValues[j].getAttribute("id");
		    	  var count= writePointRowId.substring(ModbusUtil.eighteenNumber),
		    	  count = Number(count);
				  var writePointTableCheckRowId = ModbusWritePointsConfig.checkBoxWritePoint+count;
				  var writePointTableRowId = "#"+writePointRowId;
				  if($(writePointTableCheckRowId).prop("checked") == true){
					showDeleteWarningDialogAndPtsTobeDeleted(false,widget);
					anyChkBoxNotSelected = false;
					break;
				  }
			  }	
		  }
	  
	  if(anyChkBoxNotSelected == true){
		  modbusUtil.showWarningDialogAndPtsTobeDeleted(false);
	   }	  
	 }

 function showDeleteWarningDialogAndPtsTobeDeleted(ptTypeRead,widget){
		 dialogs.showOkCancel({
			  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
			  content:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.delete'):honIrmControlLex.get('honIrmControlLex.writepoint.delete'),
			  private: false	  
		       })
			 .ok(function () {
			    if(ptTypeRead == true ){
			    	deleteSelectedReadPointsFromTable(widget);
			    }else{
			    	deleteSelectedWritePointsFromTable(widget);
			    }
			  }).cancel(function () {
				  return true;
			  });
     }
 
  function addModbusWritePointDialog(widget){  
	  var addDialogDom;
	  var modbusDeviceWritePtObj = baja.$('honIrmControl:ModbusWritePoint');
	  
	  $( "#addButtonWritePointId" ).click(function(event) {
			 //create dialog
			  event.preventDefault();
			  dialogs.showOkCancel({
			         title: honIrmControlLex.get('honIrmControlLex.add.writepoint.dialog.title.label'),
			         content: function(dlg, dlgAddWritePtJq) {
			        	 dlgAddWritePtJq.html(modbusWritePointDialog({
			            	 //lexicon text goes here
			        		 WritePointName: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointName.label'),
			        		 WritePointType: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointType.label'),
			        		 WritePointAddressDialog: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointAddress.label'),
			        		 pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.writepoint.address.range'),
			        		 SignificantChange: honIrmControlLex.get('honIrmControlLex.writepoint.SignificantChange.label'),
			        		 WritePointDataFormat: honIrmControlLex.get('honIrmControlLex.writepoint.WriteDataFormat.label'),
			             }));
			             //populate the data in add dialog 
			        	 //write Point type
			            var writePointTypeAddDialogId = getWritePointTypeOnDialogId(dlgAddWritePtJq);
			     		var optionPtType = '',
			     		writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var i=0;i<writePtTypeOrdinals.length;i++){		
			    				var optionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
			    				optionPtType += '<option value="'+ writePtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
			    		}
			    		writePointTypeAddDialogId.append(optionPtType);
			    		writePointTypeAddDialogId.val(writePtTypeOrdinals[0].toString());
			           
			    		//data format
			            var writePointDataFormatAddDialogId = getWritePointDataFormatDialogId(dlgAddWritePtJq);
			     		var optionDataFormat = '',
			     		writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var k=0;k<writePtDataFormatOrdinals.length;k++){		
			    				var optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
			    				optionDataFormat += '<option value="'+ writePtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
			    		}
			    		writePointDataFormatAddDialogId.append(optionDataFormat);
			    		writePointDataFormatAddDialogId.val(writePtDataFormatOrdinals[0].toString());
			    		addDialogDom = dlgAddWritePtJq;
			             },
			         private: false //ensures background contents are screened when the dialog is showing
			       })
			       .ok(function (dlg) {
			    	var isErrorShown = addRowToWritePointTableOnAdd(addDialogDom,modbusDeviceWritePtObj,widget,dlg);
			    	 if(isErrorShown == true){
			    		 return false;
			    	 }
                   widget.setModified(true);
			       })
			       .cancel(function (dlg) {
			    	   return true;
				    });
	
			});  
     }

  function handleModbusReadPointOperationTypeEventDialog(dlgReadPtJq,isAdd){   
	  dlgReadPtJq.on("change", "#readPointOperationModeDialogId",function(event){
		  hideShowPollTimeFields(dlgReadPtJq);
		});
  
  }
  
  function hideShowPollTimeFields(dlgReadPtJq){
	  var readPointOperationModeDialogId = getOperationModeDialogId(dlgReadPtJq);
	  var readPointPollTimeLabelId = getReadPtPollTimeLabelId(dlgReadPtJq);
	  var readPointPollTimeDialogId = getReadPtPollTimeDialogId(dlgReadPtJq);
	  var readPointPollTimeRangeDialogId = getReadPtPollTimeRangeLabelId(dlgReadPtJq);
	  if(readPointOperationModeDialogId.val() == ModbusReadPointsConfig.userDefinedMode){
		  readPointPollTimeLabelId.show();
		  readPointPollTimeDialogId.show();
		  readPointPollTimeRangeDialogId.show();
		  readPointPollTimeDialogId.val(60);
		  
	  }else{
		  readPointPollTimeLabelId.hide();
		  readPointPollTimeDialogId.hide();
		  readPointPollTimeRangeDialogId.hide();
		  readPointPollTimeDialogId.val(0);
	  }
  }
  
  
  function hideShowPollTime1stTimeOnAddEditFields(dlgReadPtJq,isAdd){
	  var readPointOperationModeDialogId = getOperationModeDialogId(dlgReadPtJq);
	  var readPointPollTimeLabelId = getReadPtPollTimeLabelId(dlgReadPtJq);
	  var readPointPollTimeDialogId = getReadPtPollTimeDialogId(dlgReadPtJq);
	  var readPointPollTimeRangeDialogId = getReadPtPollTimeRangeLabelId(dlgReadPtJq);
	  if(readPointOperationModeDialogId.val() == ModbusReadPointsConfig.userDefinedMode){
		  readPointPollTimeLabelId.show();
		  readPointPollTimeDialogId.show();
		  readPointPollTimeRangeDialogId.show();  
	  }else{
		  readPointPollTimeLabelId.hide();
		  readPointPollTimeDialogId.hide();
		  readPointPollTimeRangeDialogId.hide();
		  if(isAdd == true){
			  readPointPollTimeDialogId.val(0);  
			  }
	  }
  }
  
  
  function addModbusReadPointDialog(widget){  
	  var addDialogDom;
	  var modbusDeviceReadPtObj = baja.$('honIrmControl:ModbusReadPoint');
	  
	  $( "#addButtonReadPointId" ).click(function(event) {
			 //create dialog
			  event.preventDefault();
			  dialogs.showOkCancel({
			         title: honIrmControlLex.get('honIrmControlLex.add.readpoint.dialog.title.label'),
			         content: function(dlg, dlgAddReadPtJq) {
			        	 dlgAddReadPtJq.html(templateReadPointDialog({
			            	 //lexicon text goes here
			       	      ReadPointName: honIrmControlLex.get('honIrmControlLex.readpoint.name.label'),
			    	      ReadPointType: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointType.label'),
			    	      ReadPointAddressDialog: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointAddress.label'),
			    	      pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.readpoint.address.range'),
			    	      ReadPointOperationMode: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointOperationMode.label'),
			    	      ReadPointPollTime: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.label'),
			    	      ReadPointPollTimeRange: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.range'),
			    	      ScalingFactor: honIrmControlLex.get('honIrmControlLex.readpoint.ScalingFactor.label'),
			    	      ScalingFactorRange: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.scalingFactor.range'),
			    	      ReadDataFormat: honIrmControlLex.get('honIrmControlLex.readpoint.DataFormat.label'),
			    	      EventBitMasking: honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label'),
			    	      EventBitMaskingRange:  honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.eventBitMasking.range'),
			             }));
			        	
			        	 
			             //populate the data in add dialog 
			        	 //read Point type
			            var readPointTypeAddDialogId = getReadPointTypeOnDialogId(dlgAddReadPtJq);
			     		var optionPtType = '',
			     		readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var i=0;i<readPtTypeOrdinals.length;i++){		
			    				var optionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
			    				optionPtType += '<option value="'+ readPtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
			    		}
			    		readPointTypeAddDialogId.append(optionPtType);
			    		readPointTypeAddDialogId.val(readPtTypeOrdinals[0].toString());
			             // OperationMode
			            var readPointOperationModeAddDialogId =  getOperationModeDialogId(dlgAddReadPtJq);
			     		var optionOperationMode = '';
			    		for (var j=0;j<widget.readPtOperationModeOrdinals.length;j++){		
			    			    var optionPointOperationModeVal =  widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
			    				optionOperationMode += '<option value="'+ widget.readPtOperationModeOrdinals[j] + '">' + optionPointOperationModeVal + '</option>';
			    		}
			    		readPointOperationModeAddDialogId.append(optionOperationMode);
			    		readPointOperationModeAddDialogId.val(widget.readPtOperationModeOrdinals[1].toString());
			    		//data format
			            var readPointDataFormatAddDialogId = getDataFormatDialogId(dlgAddReadPtJq);
			     		var optionDataFormat = '',
			     		readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var k=0;k<readPtDataFormatOrdinals.length;k++){		
			    				var optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
			    				optionDataFormat += '<option value="'+ readPtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
			    		}
			    		readPointDataFormatAddDialogId.append(optionDataFormat);
			    		readPointDataFormatAddDialogId.val(readPtDataFormatOrdinals[0].toString());
			    		addDialogDom = dlgAddReadPtJq;
			    		
			    		handleModbusReadPointOperationTypeEventDialog(dlgAddReadPtJq,true);
			    		hideShowPollTime1stTimeOnAddEditFields(dlgAddReadPtJq,true);
			    		
			             },
			         private: false //ensures background contents are screened when the dialog is showing
			         
			       })
			       .ok(function () {
			    	 var isErrorDialogShown = addRowToReadPointTableOnAdd(addDialogDom,modbusDeviceReadPtObj,widget);
			    	 if(isErrorDialogShown == true){
			    		 return false;
			    	 }
			    	 widget.setModified(true);
			       })
			       .cancel(function () {
			    	   return true;
				    });			  
			});  
     }
  
  function createModbusOverviewContent(modbusDevice, widget){
	  var modbusDevNameDom = getModBusDeviceName(),
	  modbusDevAddressDom= getModBusDeviceAddress(),
	  modbusDevByteOrderDom = getModBusDeviceByteOrder(),
	  modbusDevPointCountDom = getModBusDevicePointCount();
   
	  modbusDevNameDom.text(modbusDevice.getDisplayName()); 
	  
	  var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
	  var getModbusPropFunction  = "getModbusDeviceProperties";

	  return modbusDevice.serverSideCall({
		  typeSpec:   modbusServerSideclassName,
		  methodName: getModbusPropFunction
	   })
	  	.then(function(modbusDevicePropResult) {	  				
	  			loadModBusModBusDeviceAddressInView(modbusDevAddressDom,modbusDevicePropResult);	  				
	  			loadModBusByteOrderInView(modbusDevByteOrderDom,modbusDevicePropResult);   
	  			loadModBusPointCountInView(modbusDevPointCountDom,modbusDevicePropResult);
	  		    widget.readPtOperationModeOrdinals = modbusDevicePropResult.get(readPtOperationMode).$range.getOrdinals();
	  		    widget.readPtOperationModeRange = modbusDevicePropResult.get(readPtOperationMode).$range;
	  			})
     .catch(function(err) {
       return Promise.reject(err);
     });

  }
  
  function populateModbusReadPointsTable(widget,modbusReadInputsResult) {	
	  var modbusReadPointsArr = modbusReadInputsResult.getSlots().properties().is("baja:Component").toValueArray();
	  var dom = widget.jq();
	 
	  var inputTableBody = getReadPointTableFromDocument(); //modbus-comp-table-body div   <span class="tooltiptext">Tooltip text</span>
	  
	  var modbusDeviceReadPtObj = baja.$('honIrmControl:ModbusReadPoint');
	  var readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  
	  var readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  
	  for (var i = 0; i <modbusReadPointsArr.length; i++) {
	   var readPointTableRowId = "readPointTableRow"+i,
		       readPtName = baja.SlotPath.unescape(modbusReadPointsArr[i].getReadPointName()),
		       readPtTypeOrdinal = modbusReadPointsArr[i].getReadPointType().$ordinal,
		       readPtAddress = modbusReadPointsArr[i].getReadPointAddress(),
		       readPtOperationMode = modbusReadPointsArr[i].getOperationMode().$ordinal,
		       readPtPollTime =      modbusReadPointsArr[i].getPollTime(),
		       readPtScalingFactor = modbusReadPointsArr[i].getScalingFactor(),
		       readPtDataFormat = modbusReadPointsArr[i].getDataFormat().$ordinal,
		       readPointTableRowIdJq = "#"+readPointTableRowId,
		       oldFb = modbusReadPointsArr[i].getOldFb(),		       
		   	   oldPointName = modbusReadPointsArr[i].getOldPointName(),
		   	   existingSlotPath = modbusReadPointsArr[i].getExistingSlotPath(),
		       readPtEventBitMasking = modbusUtil.convertAndshowInHex(modbusReadPointsArr[i].getEventBitMasking()), //long value
		       checkBoxReadPtId = "checkBoxReadPoint"+i,
		       optionPointTypeVal,
		       optionPointOperationModeVal,
		       optionPointDataFormatVal;
	   

		            
		   for (var m=0;m<readPtTypeOrdinals.length;m++){				   
			   if(readPtTypeOrdinal == readPtTypeOrdinals[m]){
				   optionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[m]);
				   break;
			   }		   
		   }
		   
		   for (var j=0;j< widget.readPtOperationModeOrdinals.length;j++){
			   if(readPtOperationMode ==  widget.readPtOperationModeOrdinals[j]){
				   optionPointOperationModeVal =  widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
				   break;
			   }
		   }
		   
		   for (var k=0;k<readPtDataFormatOrdinals.length;k++){
			   if(readPtDataFormat == readPtDataFormatOrdinals[k]){
				  optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
				  break;
			   }
		   }
		   
		     
		    inputTableBody.innerHTML += "<div class=\"md-table-row\" id="+ readPointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
	        "<div class=\"modbus-comp-table-cell\" title=\""+readPtName+"\" data="+"\""+ readPtName +"\""+" >"+ readPtName+" </div>  "  +
	        "<div class=\"modbus-comp-table-cell\" title=\""+ optionPointTypeVal +"\" data="+"\""+readPtTypeOrdinal +"\""+" >"+ optionPointTypeVal +" </div> " +
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtAddress +"\""+" >"+readPtAddress +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtOperationMode   +"\""+" >"+ optionPointOperationModeVal +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtPollTime+"\""+" >"+ modbusReadPointsArr[i].getPollTimeDisplay() +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtScalingFactor+"\""+" >"+ modbusReadPointsArr[i].getScalingFactorDisplay() +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtDataFormat  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtEventBitMasking +"\""+" >"+readPtEventBitMasking +" </div> "+  //convert to hex and show as from station it comes as long
	        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxReadPtId +" type=\"checkbox\"  />" + " </div> "+
	        "</div>";
		    
  	
	    
		    var param = {
			    	mainView:widget,
			    	rowIdJq:readPointTableRowIdJq,
			    	readPtName: readPtName,
			    	readPtTypeOrdinal: readPtTypeOrdinal,
			    	readOptionPointTypeVal: optionPointTypeVal,
			    	readPtAddress: readPtAddress,
			    	readPtOperationMode:readPtOperationMode,
			    	readPtOperationModeVal:optionPointOperationModeVal,
			    	readPtPollTime:readPtPollTime,
			    	readPtScalingFactor: readPtScalingFactor,
			    	readPtDataFormat: readPtDataFormat,
			    	optionPointDataFormatVal: optionPointDataFormatVal,
			    	oldFb:oldFb,
			    	oldPointName:oldPointName,
			    	existingSlotPath: existingSlotPath,
			    	readPtEventBitMasking:readPtEventBitMasking
			     };
		    
		    
			dom.on("change", "#"+checkBoxReadPtId,widget, function(event){
				modbusReadPointsConfig.handleSelectAllCheckBoxStatusFromReadPointsTable( "#"+event.currentTarget.id,event.data);
				});
		    
		    dom.on('click', readPointTableRowIdJq,
		    		param,
		    		 function (event) {      	
			        	initializeEditDialogForReadPoint(event);
				     });
		    
		    widget.readPointDataList[checkBoxReadPtId] = param;
		    
		    
		    
		    dom.on("mouseover", "#"+checkBoxReadPtId, function() {
		    	dom.off('click', widget.readPointDataList[this.id].rowIdJq);
		    });		    
		    
		    dom.on("mouseout", "#"+checkBoxReadPtId, function() {
		    	dom.on('click', widget.readPointDataList[this.id].rowIdJq,
		    			widget.readPointDataList[this.id],
			     function (event) {      	
			        	initializeEditDialogForReadPoint(event);
				     });
		    });	
		    
		    }
	  
	    modbusReadPointsConfig.sortReadTableOnSelectedFilter(widget,ModbusReadPointsConfig.activeFilterReadPts);
	  
	  
	   setModBusDeviceReadWritePointCount(true,Object.keys(widget.readPointDataList).length);
	}
  
  
  function populateModbusWritePointsTable(widget,modbusWriteInputsResult) {
	  var modbusWritePointsArr = modbusWriteInputsResult.getSlots().properties().is("baja:Component").toValueArray();
	  var dom = widget.jq();
	 
	  var ouputTableBody = getWritePointTableFromDocument(); //modbus-comp-table-body div   <span class="tooltiptext">Tooltip text</span>
	  
	  var modbusDeviceWritePtObj = baja.$('honIrmControl:ModbusWritePoint');
	  var writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  
	  for (var i = 0; i <modbusWritePointsArr.length; i++) {
		  
		   var writePointTableRowId = "writePointTableRow"+i,
		       writePtName = baja.SlotPath.unescape(modbusWritePointsArr[i].getName()),
		       writePtTypeOrdinal = modbusWritePointsArr[i].getWritePointType().$ordinal,
		       writePtAddress = modbusWritePointsArr[i].getWritePointAddress(),
		       writePtSignificantChange = modbusWritePointsArr[i].getSignificantChange(),
		       writePtDataFormatOrdinal = modbusWritePointsArr[i].getDataFormat().$ordinal,
		       writePointTableRowIdJq = "#"+writePointTableRowId,
		       oldFb = modbusWritePointsArr[i].getOldFb(),		       
		   	   oldPointName = modbusWritePointsArr[i].getOldPointName(),
		   	   existingSlotPath = modbusWritePointsArr[i].getExistingSlotPath(),
		       checkBoxWritePtId = "checkBoxWritePoint"+i,
		       optionPointTypeVal,
		       optionPointDataFormatVal;
		   
		   
		   for (var m=0;m<writePtTypeOrdinals.length;m++){	
			   if(writePtTypeOrdinal == writePtTypeOrdinals[m]){
			   optionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[m]);
			   break;
			   }
		   }
		   
		   for (var k=0;k<writePtDataFormatOrdinals.length;k++){
			   if(writePtDataFormatOrdinal == writePtDataFormatOrdinals[k]){
			   optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
			   break;
			   }
		   }
		     
		   ouputTableBody.innerHTML += "<div class=\"md-table-row\" id="+ writePointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
	        "<div class=\"modbus-comp-table-cell\" title=\""+writePtName+"\" data="+"\""+ writePtName +"\""+" >"+ writePtName+" </div>  "  +
	        "<div class=\"modbus-comp-table-cell\" title=\""+ optionPointTypeVal +"\" data="+"\""+writePtTypeOrdinal +"\""+" >"+ optionPointTypeVal +" </div> " +
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePtAddress +"\""+" >"+writePtAddress +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePtSignificantChange   +"\""+" >"+ modbusWritePointsArr[i].getSignificantChangeDisplay() +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePtDataFormatOrdinal  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
	        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxWritePtId +" type=\"checkbox\"  />" + " </div> "+
	        "</div>";
		    
		    
			dom.on("change", "#"+checkBoxWritePtId, widget,function(event){
			    modbusWritePointsConfig.handleSelectAllCheckBoxStatusFromWritePointsTable( "#"+event.currentTarget.id,event.data);
				});  	
	    
		    var param = {
			    	mainView:widget,
			    	rowIdJq:writePointTableRowIdJq,
			    	writePtName: writePtName,
			    	writePtTypeOrdinal: writePtTypeOrdinal,
			    	writePtTypeValue:optionPointTypeVal,
			    	writePtAddress: writePtAddress,
			    	writePtSignificantChange: writePtSignificantChange,
			    	writePtDataFormatOrdinal: writePtDataFormatOrdinal,
			    	writePtDataFormatValue:optionPointDataFormatVal,
			    	oldFb:oldFb,
			    	oldPointName:oldPointName,
			    	existingSlotPath: existingSlotPath
			     };
		    
		    widget.writePointDataList[checkBoxWritePtId] = param;
		    
		    dom.on('click', writePointTableRowIdJq,
		    		widget.writePointDataList[checkBoxWritePtId],		    		
		    		 function (event) {      	
			        	initializeEditDialogForWritePoint(event);
				     });
		    
		    
		    dom.on("mouseover", "#"+checkBoxWritePtId, function() {
		    	dom.off('click', widget.writePointDataList[this.id].rowIdJq);
		    });		    
		    
		    dom.on("mouseout", "#"+checkBoxWritePtId, function() {
		    	dom.on('click', widget.writePointDataList[this.id].rowIdJq,
		    			widget.writePointDataList[this.id],
			     function (event) {      	
		    		initializeEditDialogForWritePoint(event);
				     });
		    });	
    
		    }
	  
	  modbusWritePointsConfig.sortWriteTableOnSelectedFilter(widget,ModbusWritePointsConfig.activeFilterWritePts);
	  
	  setModBusDeviceReadWritePointCount(false,Object.keys(widget.writePointDataList).length);
	  
  }
  
  function initializeEditDialogForWritePoint(event){
	  var mainView = event.data.mainView;
	  var editDialogDom;
	  var rowWritePtId =  event.data.rowIdJq;
	  var modbusDeviceWritePtObj = baja.$('honIrmControl:ModbusWritePoint');
	  event.preventDefault();
	  dialogs.showOkCancel({
	         title: honIrmControlLex.get('honIrmControlLex.Edit.writepoint.dialog.title.label'),
	         content: function(dlg, dlgEditWritePtJq) {
	        	 dlgEditWritePtJq.html(modbusWritePointDialog({
	            	 //lexicon text goes here
	        		 WritePointName: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointName.label'),
	        		 WritePointType: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointType.label'),
	        		 WritePointAddressDialog: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointAddress.label'),
	        		 pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.writepoint.address.range'),
	        		 SignificantChange: honIrmControlLex.get('honIrmControlLex.writepoint.SignificantChange.label'),
	    	         WritePointDataFormat: honIrmControlLex.get('honIrmControlLex.writepoint.WriteDataFormat.label'),
	             }));
	             //populate the data in Edit dialog 
	        	 //read Point type 
	            var writePointTypeEditDialogId = getWritePointTypeOnDialogId(dlgEditWritePtJq);
	     		var optionPtType = '',
	     		writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var i=0;i<writePtTypeOrdinals.length;i++){		
	    				var optionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
	    				optionPtType += '<option value="'+ writePtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
	    		}
	    		writePointTypeEditDialogId.append(optionPtType);
	    		writePointTypeEditDialogId.val(event.data.writePtTypeOrdinal);
	    		//data format
	            var writePointDataFormatEditDialogId = getWritePointDataFormatDialogId(dlgEditWritePtJq);
	     		var optionDataFormat = '',
	     		writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var k=0;k<writePtDataFormatOrdinals.length;k++){		
	    				var optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
	    				optionDataFormat += '<option value="'+ writePtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
	    		}
	    		writePointDataFormatEditDialogId.append(optionDataFormat);
	    		writePointDataFormatEditDialogId.val(event.data.writePtDataFormatOrdinal);
	    			
	    		
	    	   var significantChangerEditDialogId = getSignificantChangeDialogId(dlgEditWritePtJq);
	    	   significantChangerEditDialogId.val(event.data.writePtSignificantChange);
	    	   var writePointAddressEditDialogId = getWritePointAddressDialogId(dlgEditWritePtJq);
	    	   writePointAddressEditDialogId.val(event.data.writePtAddress);
	    	   var writePointNameEditDialogId = getWritePointNameDialogId(dlgEditWritePtJq);
	    	   writePointNameEditDialogId.val(event.data.writePtName);
	    		
	    	   editDialogDom = dlgEditWritePtJq;
	             },
	         private: false //ensures background contents are screened when the dialog is showing
	       })
	       .ok(function () {
	    	 var isShownErrorDialog = EditRowToWritePointTable(editDialogDom,modbusDeviceWritePtObj,rowWritePtId,mainView);
	    	 if(isShownErrorDialog == true){
	    		 return false;
	    	 }
	    	 mainView.setModified(true);
	       })
	       .cancel(function () {
	    	   return true;
		    });	
	  
  }
  
  
  function initializeEditDialogForReadPoint(event){
	  var mainView = event.data.mainView;
	  var editDialogDom;
	  var rowReadPtId =  event.data.rowIdJq;
	  var modbusDeviceReadPtObj = baja.$('honIrmControl:ModbusReadPoint');
	  event.preventDefault();
	  dialogs.showOkCancel({
	         title: honIrmControlLex.get('honIrmControlLex.Edit.readpoint.dialog.title.label'),
	         content: function(dlg, dlgEditReadPtJq) {
	        	 dlgEditReadPtJq.html(templateReadPointDialog({
	            	 //lexicon text goes here
	       	      ReadPointName: honIrmControlLex.get('honIrmControlLex.readpoint.name.label'),
	    	      ReadPointType: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointType.label'),
	    	      ReadPointAddressDialog: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointAddress.label'),
	    	      pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.readpoint.address.range'),
	    	      ReadPointOperationMode: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointOperationMode.label'),
	    	      ReadPointPollTime: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.label'),
	    	      ReadPointPollTimeRange: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.range'),
	    	      ScalingFactor: honIrmControlLex.get('honIrmControlLex.readpoint.ScalingFactor.label'),
	    	      ScalingFactorRange: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.scalingFactor.range'),
	    	      ReadDataFormat: honIrmControlLex.get('honIrmControlLex.readpoint.DataFormat.label'),
	    	      EventBitMasking: honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label'),
	    	      EventBitMaskingformat:  honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label.format'),
	    	      EventBitMaskingRange:  honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.eventBitMasking.range'),
	             }));
	             //populate the data in Edit dialog 
	        	 //read Point type 
	            var readPointTypeEditDialogId = getReadPointTypeOnDialogId(dlgEditReadPtJq);
	     		var optionPtType = '',
	     		readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var i=0;i<readPtTypeOrdinals.length;i++){		
	    				var optionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
	    				optionPtType += '<option value="'+ readPtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
	    		}
	    		readPointTypeEditDialogId.append(optionPtType);
	    		readPointTypeEditDialogId.val(event.data.readPtTypeOrdinal);
	             // OperationMode
	            var readPointOperationModeEditDialogId =  getOperationModeDialogId(dlgEditReadPtJq);
	     		var optionOperationMode = '';
	    		for (var j=0;j<mainView.readPtOperationModeOrdinals.length;j++){		
	    			    var optionPointOperationModeVal = mainView.readPtOperationModeRange.getTag(mainView.readPtOperationModeOrdinals[j]);
	    				optionOperationMode += '<option value="'+ mainView.readPtOperationModeOrdinals[j] + '">' + optionPointOperationModeVal + '</option>';
	    		}
	    		readPointOperationModeEditDialogId.append(optionOperationMode);
	    		readPointOperationModeEditDialogId.val(event.data.readPtOperationMode);
	    		//data format
	            var readPointDataFormatEditDialogId = getDataFormatDialogId(dlgEditReadPtJq);
	     		var optionDataFormat = '',
	     		readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var k=0;k<readPtDataFormatOrdinals.length;k++){		
	    				var optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
	    				optionDataFormat += '<option value="'+ readPtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
	    		}
	    		readPointDataFormatEditDialogId.append(optionDataFormat);
	    		readPointDataFormatEditDialogId.val(event.data.readPtDataFormat);
	    			
	    		
	    	   var scalingFactorEditDialogId = getScalingFactorDialogId(dlgEditReadPtJq);
	    	   scalingFactorEditDialogId.val(event.data.readPtScalingFactor);
	    	   var readPointAddressEditDialogId = getReadPointAddressDialogId(dlgEditReadPtJq);
	    	   readPointAddressEditDialogId.val(event.data.readPtAddress);
	    	   var readPointNameEditDialogId = getReadPointNameDialogId(dlgEditReadPtJq);
	    	   readPointNameEditDialogId.val(event.data.readPtName);
	    	   var readPointEventBitMaskingDialogId = getReadPointEventBitMaskingDialogId(dlgEditReadPtJq);
	    	   readPointEventBitMaskingDialogId.val(event.data.readPtEventBitMasking);
	    	   
	    	   var readPtPollTimeEditDialogId = getReadPtPollTimeDialogId(dlgEditReadPtJq);
	    	   readPtPollTimeEditDialogId.val(event.data.readPtPollTime);
	    	   
	    		
	    	   editDialogDom = dlgEditReadPtJq;
	    	   
	    	   handleModbusReadPointOperationTypeEventDialog(dlgEditReadPtJq,false);
	    	   hideShowPollTime1stTimeOnAddEditFields(dlgEditReadPtJq,false);
	             },
	         private: false //ensures background contents are screened when the dialog is showing
	       })
	       .ok(function () {
	    	 var isErrorDialogShown = EditRowToReadPointTable(editDialogDom,modbusDeviceReadPtObj,rowReadPtId,mainView);
	    	 if(isErrorDialogShown == true){
	    		 return false;
	    	 }
	    	 mainView.setModified(true);
	       })
	       .cancel(function () {
	    	   return true;
		    });	
	  
  }
  
  
  function  EditRowToWritePointTable(dlgEditWritePtJq,modbusDeviceWritePtObj,rowWritePtId,widget){
	  
	  var dom = widget.jq();
		//scaling factor
	   var significantChangeEditDialogId = getSignificantChangeDialogId(dlgEditWritePtJq);
	   var writePointAddressEditDialogId = getWritePointAddressDialogId(dlgEditWritePtJq);
	   var writePointNameEditDialogId = getWritePointNameDialogId(dlgEditWritePtJq);
	   
		  
	   var significantChangeVal = significantChangeEditDialogId.val();
	   var writePointAddressVal = writePointAddressEditDialogId.val()
	   var writePointNameVal = writePointNameEditDialogId.val();
	   
	   var isShownErrorDialog = modbusWritePointsConfig.showErrorDiaogOnAddEditWritePoint(significantChangeVal,writePointAddressVal,writePointNameVal);
	   if(isShownErrorDialog == true ){
			  return isShownErrorDialog;
		  }
	  
	  //read point type
	  var writePointTypeEditDialogId = getWritePointTypeOnDialogId(dlgEditWritePtJq);  
	  var writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var writeOptionPointTypeVal;
		for (var i=0;i<writePtTypeOrdinals.length;i++){				
			if(writePtTypeOrdinals[i]  == writePointTypeEditDialogId.val() ){
				writeOptionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
				break;
			}
		}
    
		//read point data format
	  var writePointDataFormatEditDialogId = getWritePointDataFormatDialogId(dlgEditWritePtJq);
	  var optionPointDataFormatVal;

	 var writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<writePtDataFormatOrdinals.length;k++){						
				if(writePtDataFormatOrdinals[k]  == writePointDataFormatEditDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
					break;
				}
		}
		
	     var count= rowWritePtId.substring(19);//#writePointTableRow0
	     var countNumber = Number(count);

		  var checkBoxWritePtId = "checkBoxWritePoint"+countNumber;
		  
		  var existingParam = widget.writePointDataList[checkBoxWritePtId];
		
		    var param = {
			    	mainView:widget,
			    	rowIdJq:rowWritePtId,
			    	writePtName: writePointNameVal,
			    	writePtTypeOrdinal: writePointTypeEditDialogId.val(), 
			    	writePtTypeValue:writeOptionPointTypeVal,
			    	writePtAddress: writePointAddressVal,
			    	writePtSignificantChange: significantChangeVal,
			    	writePtDataFormatOrdinal: writePointDataFormatEditDialogId.val(),
			    	writePtDataFormatValue:optionPointDataFormatVal,
			    	oldFb: existingParam.oldFb,
			    	oldPointName: existingParam.oldPointName,
			    	existingSlotPath: existingParam.existingSlotPath
			     };
		    
			   var isError = modbusWritePointsConfig.validateWritePtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
			   if(isError == true){
				   return isError;
			   }
    
		    widget.writePointDataList[checkBoxWritePtId] = param;

		    dom.off('click', widget.writePointDataList[checkBoxWritePtId].rowIdJq);
		  
		    dom.on('click', widget.writePointDataList[checkBoxWritePtId].rowIdJq,
		    			widget.writePointDataList[checkBoxWritePtId],
			     function (event) {      	
		    		initializeEditDialogForWritePoint(event);
		   });


   
	  var writePointcells = $(rowWritePtId).find("div.modbus-comp-table-cell");
	  
	  for (var l = 0; l <writePointcells.length; l++) { // 0 1 2 3
			 if( l==0 ){
				 writePointcells[l].innerText = writePointNameVal;
				 writePointcells[l].setAttribute("data",writePointNameVal);
				 writePointcells[l].setAttribute("title",writePointNameVal);
			 }
			 else if(l==1){
				 writePointcells[l].innerText = writeOptionPointTypeVal;
				 writePointcells[l].setAttribute("data",writePointTypeEditDialogId.val());
				 writePointcells[l].setAttribute("title",writeOptionPointTypeVal);
			 }			 
			 else if(l==2){
				 writePointcells[l].setAttribute("data",writePointAddressVal);
				 
				 if(writePointAddressVal.toString().toUpperCase().includes("0X")){
					 writePointcells[l].innerText = modbusUtil.showAddressInDecAndHexFromHex(writePointAddressVal); 
				 }else{
					 writePointcells[l].innerText = modbusUtil.showAddressInDecAndHex(writePointAddressVal); 
				 }
			 }
			 else if(l==3){			 
				 writePointcells[l].innerText = significantChangeVal;
				 writePointcells[l].setAttribute("data",significantChangeVal); 
			 } 
			 else if(l==4){
				 writePointcells[l].innerText = optionPointDataFormatVal;
				 writePointcells[l].setAttribute("data",writePointDataFormatEditDialogId.val()); 
			 }  
		  } 
	  
	  modbusWritePointsConfig.sortWriteTableOnSelectedFilter(widget,ModbusWritePointsConfig.activeFilterWritePts);
	  
  }
  
  
  function  EditRowToReadPointTable(dlgEditReadPtJq,modbusDeviceReadPtObj,rowReadPtId,widget){
	  
	  var dom = widget.jq();
		//scaling factor
  	  
	  var scalingFactorEditDialogId = getScalingFactorDialogId(dlgEditReadPtJq);
	  var readPointAddressEditDialogId = getReadPointAddressDialogId(dlgEditReadPtJq);
	  var readPointNameEditDialogId = getReadPointNameDialogId(dlgEditReadPtJq);
	  var readPointEventBitMaskingDialogId = getReadPointEventBitMaskingDialogId(dlgEditReadPtJq);
	  var readPtPollTimeEditDialogId = getReadPtPollTimeDialogId(dlgEditReadPtJq);
	  var readPtOperationModeDialogId = getOperationModeDialogId(dlgEditReadPtJq);
	  
	  var scalingFactorEditVal =  scalingFactorEditDialogId.val();
	  var readPointAddressEditVal = readPointAddressEditDialogId.val();
	  var readPointNameEditVal = readPointNameEditDialogId.val();
	  var eventBitMaskingVal = readPointEventBitMaskingDialogId.val();
	  var readPtPollTimeEditVal =  readPtPollTimeEditDialogId.val();
	  var readPtOperationModeVal = readPtOperationModeDialogId.val();
	 
	  
	  var isErrorDialogShown = modbusReadPointsConfig.showErrorDiaogOnAddEditReadPoint(scalingFactorEditVal,readPointAddressEditVal,readPointNameEditVal,eventBitMaskingVal,readPtPollTimeEditVal,readPtOperationModeVal);
	  
	  if(true == isErrorDialogShown){
		  return isErrorDialogShown;
	  }
	  
	  //read point type
	  var readPointTypeEditDialogId = getReadPointTypeOnDialogId(dlgEditReadPtJq);  
	  var readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var readOptionPointTypeVal;
		for (var i=0;i<readPtTypeOrdinals.length;i++){				
			if(readPtTypeOrdinals[i]  == readPointTypeEditDialogId.val() ){
				readOptionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
				break;
			}
		}
	  
		//read point OperationMode
	  
	  var readPointOperationModeEditDialogId =  getOperationModeDialogId(dlgEditReadPtJq);
		var readPtOperationModeVal;
		for (var j=0;j<widget.readPtOperationModeOrdinals.length;j++){
			if(widget.readPtOperationModeOrdinals[j]  == readPointOperationModeEditDialogId.val() ){
				readPtOperationModeVal = widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
				break;
			}
		}
	    
		//read point data format
	  var readPointDataFormatEditDialogId = getDataFormatDialogId(dlgEditReadPtJq);
	  var optionPointDataFormatVal;

	 var readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<readPtDataFormatOrdinals.length;k++){						
				if(readPtDataFormatOrdinals[k]  == readPointDataFormatEditDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
					break;
				}
		}

	     var count= rowReadPtId.substring(ModbusUtil.eighteenNumber); //#readPointTableRow0
	     var countNumber = Number(count);

		 var checkBoxReadPtId = "checkBoxReadPoint"+countNumber;
		  
		 var existingParam = widget.readPointDataList[checkBoxReadPtId];
		
	    var param = {
		    	mainView:widget,
		    	rowIdJq:rowReadPtId,
		    	readPtName: readPointNameEditVal,
		    	readPtTypeOrdinal: readPointTypeEditDialogId.val(), 
		    	readOptionPointTypeVal: readOptionPointTypeVal,
		    	readPtAddress: readPointAddressEditVal,
		    	readPtOperationMode:readPointOperationModeEditDialogId.val(),
		    	readPtOperationModeVal:readPtOperationModeVal,
		    	readPtPollTime:readPtPollTimeEditVal,
		    	readPtScalingFactor: scalingFactorEditVal,
		    	optionPointDataFormatVal:optionPointDataFormatVal,
		    	readPtDataFormat: readPointDataFormatEditDialogId.val(),
		    	oldFb: existingParam.oldFb,
		    	oldPointName: existingParam.oldPointName,
		    	existingSlotPath: existingParam.existingSlotPath,
		    	readPtEventBitMasking:eventBitMaskingVal
		     };
	    
	    //if point address and type is same then no need to add in read table
		   var isError = modbusReadPointsConfig.validateReadPtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
		   if(isError == true){
			   return isError;
		   }
	    
	    widget.readPointDataList[checkBoxReadPtId] = param;
	    
	    
	    dom.off('click',  widget.readPointDataList[checkBoxReadPtId].rowIdJq);
		  
	    dom.on('click',  widget.readPointDataList[checkBoxReadPtId].rowIdJq,
	    		 widget.readPointDataList[checkBoxReadPtId],
		     function (event) {      	
	    	initializeEditDialogForReadPoint(event);
	   });
		

	  var readPointcells = $(rowReadPtId).find("div.modbus-comp-table-cell");
	  
	  for (var l = 0; l <readPointcells.length; l++) { // 0 1 2 3
			 if( l==0 ){
				 readPointcells[l].innerText = readPointNameEditVal;
				 readPointcells[l].setAttribute("data",readPointNameEditVal);
				 readPointcells[l].setAttribute("title",readPointNameEditVal);
			 }
			 else if(l==1){
				 readPointcells[l].innerText = readOptionPointTypeVal;
				 readPointcells[l].setAttribute("data",readPointTypeEditDialogId.val());
				 readPointcells[l].setAttribute("title",readOptionPointTypeVal);
			 }			 
			 else if(l==2){
				 readPointcells[l].setAttribute("data",readPointAddressEditVal);
				 
				 if(readPointAddressEditVal.toString().toUpperCase().includes("0X")){
					 readPointcells[l].innerText = modbusUtil.showAddressInDecAndHexFromHex(readPointAddressEditVal);
				 }else{
					 readPointcells[l].innerText = modbusUtil.showAddressInDecAndHex(readPointAddressEditVal);
				 }
				 
			 }				 
			 else if(l==3){
				 readPointcells[l].innerText = readPtOperationModeVal;
				 readPointcells[l].setAttribute("data",readPointOperationModeEditDialogId.val()); 
			 }
			 else if(l==4){
				 readPointcells[l].innerText = readPtPollTimeEditVal;
				 readPointcells[l].setAttribute("data",readPtPollTimeEditVal); 
			 }
			 else if(l==5){			 
				 readPointcells[l].innerText = scalingFactorEditVal;
				 readPointcells[l].setAttribute("data",scalingFactorEditVal); 
			 } 
			 else if(l==6){
				 readPointcells[l].innerText = optionPointDataFormatVal;
				 readPointcells[l].setAttribute("data",readPointDataFormatEditDialogId.val()); 
			 } else if(l==7){
				 readPointcells[l].innerText = modbusUtil.showInHex(eventBitMaskingVal);
				 readPointcells[l].setAttribute("data",eventBitMaskingVal); 
			 }  
		  }  
	  
	  modbusReadPointsConfig.sortReadTableOnSelectedFilter(widget,modbusReadPointsConfig.activeFilterReadPts);
  }
  
  function  addRowToWritePointTableOnAdd(dlgAddWritePtJq,modbusDeviceWritePtObj,widget,dlg){
	  
		//scaling factor
  	  
	  var significantChangeAddDialogId = getSignificantChangeDialogId(dlgAddWritePtJq);
	  var writePointAddressAddDialogId = getWritePointAddressDialogId(dlgAddWritePtJq);
	  var writePointNameAddDialogId = getWritePointNameDialogId(dlgAddWritePtJq);
	  
	  var significantChangeVal = significantChangeAddDialogId.val();
	  var writePointAddressVal = writePointAddressAddDialogId.val()
	  var writePointNameVal = writePointNameAddDialogId.val();
	   
	  
	  var isShownErrorDialog = modbusWritePointsConfig.showErrorDiaogOnAddEditWritePoint(significantChangeVal,writePointAddressVal,writePointNameVal);
	  if(isShownErrorDialog == true ){
		  return isShownErrorDialog;
	  }
	  
	  //read point type
	  var dom = widget.jq();
	  var writePointTypeAddDialogId = getWritePointTypeOnDialogId(dlgAddWritePtJq);  
	  var writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var writeOptionPointTypeVal;
		for (var i=0;i<writePtTypeOrdinals.length;i++){				
			if(writePtTypeOrdinals[i]  == writePointTypeAddDialogId.val() ){
				writeOptionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
				break;
			}
		}
	    
		//read point data format
	  var writePointDataFormatAddDialogId = getWritePointDataFormatDialogId(dlgAddWritePtJq);
	  var optionPointDataFormatVal;

	 var writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<writePtDataFormatOrdinals.length;k++){						
				if(writePtDataFormatOrdinals[k]  == writePointDataFormatAddDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
					break;
				}
		}
	  
	  var ouputTableBody = getWritePointTableFromDocument();
	  
		var keyListChkBox=  Object.keys(widget.writePointDataList);
		var count = 0,
		writePointTableRowId,
		checkBoxWritePtId;		
		if(keyListChkBox.length > 0){
			//get the last item from keyList
		   var keyChkBoxIdLast = keyListChkBox[keyListChkBox.length-1];
		   count= keyChkBoxIdLast.substring(ModbusUtil.eighteenNumber);
		   count = Number(count)+1;
		 }      
      
      writePointTableRowId = "writePointTableRow"+count;
	  checkBoxWritePtId = "checkBoxWritePoint"+count;
	  
	   var writePtTypeOrdinal = writePointTypeAddDialogId.val(),
       writePtDataFormatOrdinal = writePointDataFormatAddDialogId.val(),
       writePointTableRowIdJq = "#"+writePointTableRowId;
	   
	    var param = {
		    	mainView:widget,
		    	rowIdJq:writePointTableRowIdJq,
		    	writePtName: writePointNameVal,
		    	writePtTypeOrdinal: writePtTypeOrdinal,
		    	writePtTypeValue:writeOptionPointTypeVal,
		    	writePtAddress: writePointAddressVal,
		    	writePtSignificantChange: significantChangeVal,
		    	writePtDataFormatOrdinal: writePtDataFormatOrdinal,
		    	writePtDataFormatValue:optionPointDataFormatVal,
		    	oldFb:false,
		    	oldPointName: "",
		    	existingSlotPath: ""
		     };
	   
	   var isError = modbusWritePointsConfig.validateWritePtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
	   if(isError == true){
		   return isError;
	   }
	   
	   
	  
	   ouputTableBody.innerHTML += "<div class=\"md-table-row\" id="+ writePointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
         "<div class=\"modbus-comp-table-cell\" title=\""+writePointNameVal+"\" data="+"\""+ writePointNameVal+"\""+" >"+  writePointNameVal+" </div>  "  +
        "<div class=\"modbus-comp-table-cell\" title=\""+writeOptionPointTypeVal+"\" data="+"\""+ writePointTypeAddDialogId.val() +"\""+" >"+ writeOptionPointTypeVal +" </div> " +
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePointAddressVal +"\""+" >"+writePointAddressVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ significantChangeVal +"\""+" >"+ significantChangeVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePointDataFormatAddDialogId.val()  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxWritePtId +" type=\"checkbox\" />" + " </div> "+
        "</div>";
	   

	    widget.writePointDataList[checkBoxWritePtId] = param;
	    
	    var initializefunction =  function (event) {      	
        	initializeEditDialogForWritePoint(event);
	     };
	     
	    dom.on('click', writePointTableRowIdJq,
	    		widget.writePointDataList[checkBoxWritePtId],
	    		initializefunction);
	    
	    dom.on("mouseover", "#"+checkBoxWritePtId, function () {
	    	dom.off("click", widget.writePointDataList[this.id].rowIdJq);	    	
	    });
	    
	    dom.on("mouseout", "#"+checkBoxWritePtId, function () {
	    	dom.on('click', widget.writePointDataList[this.id].rowIdJq,
	    			widget.writePointDataList[this.id],
		    		initializefunction); 	
	    });
	    
		dom.on("change", "#"+checkBoxWritePtId, widget,function(event){
		    modbusWritePointsConfig.handleSelectAllCheckBoxStatusFromWritePointsTable( "#"+event.currentTarget.id,event.data);
		});
		
		modbusWritePointsConfig.sortWriteTableOnSelectedFilter(widget,ModbusWritePointsConfig.activeFilterWritePts);
		
		setModBusDeviceReadWritePointCount(false,Object.keys(widget.writePointDataList).length);
	    
   }
  
  function  addRowToReadPointTableOnAdd(dlgAddReadPtJq,modbusDeviceReadPtObj,widget){
		//scaling factor
  	  
	  var scalingFactorAddDialogId = getScalingFactorDialogId(dlgAddReadPtJq);
	  var readPointAddressAddDialogId = getReadPointAddressDialogId(dlgAddReadPtJq);
	  var readPointNameAddDialogId = getReadPointNameDialogId(dlgAddReadPtJq);
	  var readPointEventBitMaskingDialogId = getReadPointEventBitMaskingDialogId(dlgAddReadPtJq);
	  var readPointPollTimeDialogId = getReadPtPollTimeDialogId(dlgAddReadPtJq);
	  var readPtOperationModeDialogId = getOperationModeDialogId(dlgAddReadPtJq);
	  
	  var scalingFactorVal = scalingFactorAddDialogId.val();
	  var readPointAddressVal = readPointAddressAddDialogId.val();
	  var readPointNameVal = readPointNameAddDialogId.val();
	  var eventBitMaskingVal = readPointEventBitMaskingDialogId.val();
	  var pollTimeVal = readPointPollTimeDialogId.val();
	  var readPtOperationModeVal = readPtOperationModeDialogId.val();
	  
	  
	  var isErrorDialogShown = modbusReadPointsConfig.showErrorDiaogOnAddEditReadPoint(scalingFactorVal,readPointAddressVal,readPointNameVal,eventBitMaskingVal,pollTimeVal,readPtOperationModeVal);
	  
	  if(true == isErrorDialogShown){
		  return isErrorDialogShown;
	  }

	  
	  //read point type
	  var dom = widget.jq();
	  var readPointTypeAddDialogId = getReadPointTypeOnDialogId(dlgAddReadPtJq);  
	  var readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var readOptionPointTypeVal;
		for (var i=0;i<readPtTypeOrdinals.length;i++){				
			if(readPtTypeOrdinals[i]  == readPointTypeAddDialogId.val() ){
				readOptionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
				break;
			}
		}
	  
		//read point OperationMode
	  
	  var readPointOperationModeAddDialogId =  getOperationModeDialogId(dlgAddReadPtJq);

		for (var j=0;j<widget.readPtOperationModeOrdinals.length;j++){
			if(widget.readPtOperationModeOrdinals[j]  == readPointOperationModeAddDialogId.val() ){
				readPtOperationModeVal = widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
				break;
			}
		}
	    
		//read point data format
	  var readPointDataFormatAddDialogId = getDataFormatDialogId(dlgAddReadPtJq);
	  var optionPointDataFormatVal;

	 var readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<readPtDataFormatOrdinals.length;k++){						
				if(readPtDataFormatOrdinals[k]  == readPointDataFormatAddDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
					break;
				}
		}	  
	
		var tableBody = getReadPointTableFromDocument();
		var keyListChkBox=  Object.keys(widget.readPointDataList);
		var count = 0,
		readPointTableRowId,
		checkBoxReadPtId;		
		if(keyListChkBox.length > 0){
			//get the last item from keyList
		   var keyChkBoxIdLast = keyListChkBox[keyListChkBox.length-1];
		   count= keyChkBoxIdLast.substring(ModbusUtil.seventeenNumber);
		   count = Number(count)+1;
		 }
			
	  readPointTableRowId = "readPointTableRow"+count;
	  checkBoxReadPtId = "checkBoxReadPoint"+count;
	  
	   var readPtTypeOrdinal = readPointTypeAddDialogId.val(),
       readPtOperationMode = readPointOperationModeAddDialogId.val(),
       readPtDataFormat = readPointDataFormatAddDialogId.val(),
       readPointTableRowIdJq = "#"+readPointTableRowId;

	    var param = {
		    	mainView:widget,
		    	rowIdJq:readPointTableRowIdJq,
		    	readPtName: readPointNameVal,
		    	readPtTypeOrdinal: readPtTypeOrdinal,
		    	readOptionPointTypeVal: readOptionPointTypeVal,
		    	readPtAddress: readPointAddressVal,
		    	readPtOperationMode:readPtOperationMode,
		    	readPtOperationModeVal:readPtOperationModeVal,
		    	readPtPollTime:pollTimeVal,
		    	readPtScalingFactor: scalingFactorVal,
		    	optionPointDataFormatVal:optionPointDataFormatVal,
		    	readPtDataFormat: readPtDataFormat,
		    	oldFb: false,
		    	oldPointName: "",
		    	existingSlotPath: "",
		    	readPtEventBitMasking:eventBitMaskingVal
		     };

	    //if point address and type is same then no need to add in read table
		   var isError = modbusReadPointsConfig.validateReadPtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
		   if(isError == true){
			   return isError;
		   }
	  
	   tableBody.innerHTML += "<div class=\"md-table-row\" id="+ readPointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
         "<div class=\"modbus-comp-table-cell\" title=\""+readPointNameVal+"\" data="+"\""+ readPointNameVal+"\""+" >"+  readPointNameVal+" </div>  "  +
        "<div class=\"modbus-comp-table-cell\" title=\""+readOptionPointTypeVal+"\" data="+"\""+ readPointTypeAddDialogId.val() +"\""+" >"+ readOptionPointTypeVal +" </div> " +
        "<div class=\"modbus-comp-table-cell\" data="+"\""+readPointAddressVal +"\""+" >"+ readPointAddressVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPointOperationModeAddDialogId.val()  +"\""+" >"+ readPtOperationModeVal +" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ scalingFactorVal +"\""+" >"+ scalingFactorVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ pollTimeVal +"\""+" >"+ pollTimeVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPointDataFormatAddDialogId.val()  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ eventBitMaskingVal  +"\""+" >"+modbusUtil.showInHex(eventBitMaskingVal) +" </div> "+  
        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxReadPtId +" type=\"checkbox\" />" + " </div> "+
        "</div>";

	    widget.readPointDataList[checkBoxReadPtId] = param;
	    
	    modbusReadPointsConfig.sortReadTableOnSelectedFilter(widget,ModbusReadPointsConfig.activeFilterReadPts);
	    
	    
	    var initializefunction =  function (event) {      	
        	initializeEditDialogForReadPoint(event);
	     };
	     
	    dom.on('click', readPointTableRowIdJq,
	    		param,
	    		initializefunction);
	    
	    dom.on("mouseover", "#"+checkBoxReadPtId, function () {
	    	dom.off("click", widget.readPointDataList[this.id].rowIdJq);	    	
	    });
	    
	    dom.on("mouseout", "#"+checkBoxReadPtId, function () {
	    	dom.on('click', widget.readPointDataList[this.id].rowIdJq,
	    			widget.readPointDataList[this.id],
		    		initializefunction); 	
	    });
	    
		dom.on("change", "#"+checkBoxReadPtId,widget, function(event){
			modbusReadPointsConfig.handleSelectAllCheckBoxStatusFromReadPointsTable( "#"+event.currentTarget.id,event.data);
		});  
		
		setModBusDeviceReadWritePointCount(true,Object.keys(widget.readPointDataList).length);
	    
   }
	     
  function loadModbusReadPointsContent(modbusDevice, dom){
	  
	  var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
	  var getModbusReadPointFunc  = "getReadPointsFromModbusDevice";

	  return modbusDevice.serverSideCall({
		  typeSpec:   modbusServerSideclassName,
		  methodName: getModbusReadPointFunc
	   })
	  	.then(function(modbusReadInputsResult) {
	  		populateModbusReadPointsTable(dom,modbusReadInputsResult)

	  	})
     .catch(function(err) {
       return Promise.reject(err);
     });

  }
  
  function loadModbusWritePointsContent(modbusDevice, dom){
	  
	  var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
	  var getModbusOutputFunction  = "getWritePointsFromModbusDevice";

	  return modbusDevice.serverSideCall({
		  typeSpec:   modbusServerSideclassName,
		  methodName: getModbusOutputFunction
	   })
	  	.then(function(modbusWriteOutputsResult) {	
	  		populateModbusWritePointsTable(dom,modbusWriteOutputsResult)

	  	})
     .catch(function(err) {
       return Promise.reject(err);
     });

  }


  function showErrorDiaogOnEditOfModbusDevice(devAddressVal,modDevInputCount,isAddressExistsCheck){
	  	  
	  if(isAddressExistsCheck){
		  dialogs.showOk({
			  title: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.title'),
			  content: honIrmControlLex.get('honIrmControlLex.modbus.device.address.exists'),
			  private: false
		     })
			  .ok(function () {
			    return true;
			  });
		 return true;
	  }
	  
	  var devAddressEmpty =  modbusUtil.checkStirngAsNullOrEmpty(devAddressVal);
	  var modDevInputEmpty =  modbusUtil.checkStirngAsNullOrEmpty(modDevInputCount)
	  if(devAddressEmpty == true || modDevInputEmpty == true){
		  dialogs.showOk({
			  title: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.title'),
			  content: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.empty'),
			  private: false
		     })
			  .ok(function () {
			    return true;
			  });
		 return true;
	  }
	  if(devAddressVal <1 || devAddressVal > 247){
		  dialogs.showOk({
				  title: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.title '),
				  content: honIrmControlLex.get('honIrmControlLex.modbus.edit.deviceAddress.error'),
				  private: false
			     })
				  .ok(function () {
				    return true;
				  });
			 return true;  
	  }
	  
	  if(modDevInputCount <1 || modDevInputCount > 20 ){
		  dialogs.showOk({
				  title: honIrmControlLex.get(' honIrmControlLex.modbus.edit.error.title '),
				  content: honIrmControlLex.get('honIrmControlLex.modbus.edit.maxReadCount.error'),
				  private: false
			      })
				  .ok( function () {
				    return true;
				  });
			 return true;
	  }
	  
  }  
	  /**.
	   *
	   * Note that the parameter to this function is the same as that resolved by
	   * doRead().
	   *
	   * @returns {Promise}
	   */
	  ModbusDeviceConfigView.prototype.doSave = function (readValue) { //-------------- *NEW*
		  var widget = this,
		  isAddressExistsCheck = false,
		  dom = widget.jq();
		  
		  var isErrorOnModbus = showErrorDiaogOnEditOfModbusDevice(getModBusDeviceAddress().val(),getModBusDevicePointCount().val(),isAddressExistsCheck);
		  if(isErrorOnModbus == true){
			  return;
		  }
		 saveModbusOverviewContent(readValue,dom, widget);

	  };
	  
	  /**
	   * 
	   */
	  function saveModbusOverviewContent(modbusDevice,dom, widget){
		   var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
		   var saveModbusPropFunction  = "saveModbusDeviceProperties";
		   var validateModbusPropFunction  = "validateModbusFunctionBlock";
		    	      
		   var modbusDeviceArgsObj = baja.$('honIrmControl:ModbusDeviceArgs');
		   modbusDeviceArgsObj.add({
			    slot: "DeviceAddress",
			    value: getModBusDeviceAddress().val()
			  });
		   modbusDeviceArgsObj.add({
			    slot: "ByteOrder",
			    value: getModBusDeviceByteOrder().val()
		   });
		   modbusDeviceArgsObj.add({
				slot: "MaxReadPointCount",
				value: getModBusDevicePointCount().val()
		   });
		   
	         //if modbusdevice property is saved then only read and write pts properties should be saved.	
	   		var readPointData = modbusReadPointsConfig.getModbusReadPointTableData(dom, widget);
	   		// readPointData is true means error has been shown so do not proceed
	   		if(readPointData == true){
	   			return;
	   		}
	   	   // writePointData is true means error has been shown so do not proceed
	   		var writePointData = modbusWritePointsConfig.getModbusWritePointTableData(dom, widget);
	   		if(writePointData == true){
	   			return;
	   		}
	   		
	   		//get the deleted read pt list
	         //if modbusdevice property is saved then only read and write pts properties should be saved.	
	   		var deletedReadPointData = modbusReadPointsConfig.getModbusDeletedReadPointTableData(widget);

	   	   // writePointData is true means error has been shown so do not proceed
	   		var  deletedWritePointData = modbusWritePointsConfig.getModbusDeleteWritePointTableData(widget);

	   		modbusDeviceArgsObj.add({
				slot: "readPointList",
				value: readPointData
		   });
	   		
	   		modbusDeviceArgsObj.add({
				slot: "writePointList",
				value: writePointData
		   });
	   		
	   		if(deletedReadPointData.$map.$array.length > 0){
	   			modbusDeviceArgsObj.add({
	   				slot: "deleteReadPointList",
	   				value: deletedReadPointData
	   			});
	   		}
	   		if(deletedWritePointData.$map.$array.length > 0){
	   			modbusDeviceArgsObj.add({
	   				slot: "deleteWritePointList",
	   				value: deletedWritePointData
	   			});
	   		}
		   
		   return modbusDevice.serverSideCall({
		     typeSpec:   modbusServerSideclassName,
		     methodName: validateModbusPropFunction,
		     value:      modbusDeviceArgsObj
		     
		   })
		   .then(function(resultObject) {	
			    // modbusDevice address exists
		        if (resultObject == true) {	
		  		  var isErrorOnModbus = showErrorDiaogOnEditOfModbusDevice(getModBusDeviceAddress().val(),getModBusDevicePointCount().val(),true);
		  		  	if(isErrorOnModbus == true){
					  return;
				  	}
		        }
		        else{
		 		   return modbusDevice.serverSideCall({
		 			     typeSpec:   modbusServerSideclassName,
		 			     methodName: saveModbusPropFunction,
		 			     value:      modbusDeviceArgsObj		 			     
		 			})
		 	    // --------
		 		.then(function(resultObject) {	
		        if (resultObject == true) {
		        	
		        	 return Promise.resolve(true);
		        }
		     })

		   }
		 })
		.catch(function(err) {
		       return Promise.reject(err);
		  });	  
	  }
	    
  return ModbusDeviceConfigView;
});
