
/**
 * A module defining `ModbusUtil`.
 *
 * @module nmodule/honIrmControl/rc/ModbusUtil
 */
define(['baja!',
        'bajaux/Widget',
        'dialogs',
        'lex!honIrmControl', 
        'jquery'], function ( 
        baja,
        Widget,
        dialogs,
        lexicons,
        $ ) {
	
	
	  'use strict';	  
	  
	  var honIrmControlLex = lexicons[0];
	
	var ModbusUtil = function ModbusUtil() {
	      Widget.apply(this, arguments);
	  };
	  
	  ModbusUtil.prototype = Object.create(Widget.prototype);
	  ModbusUtil.prototype.constructor = ModbusUtil;
	  
	  ModbusUtil.seventeenNumber = 17;
	  ModbusUtil.eighteenNumber = 18;
	  
	   /**
	    * num here is in decimal
	    */
	  ModbusUtil.prototype.showAddressInDecAndHex = function(numInDec) {
	      var hex = Number(numInDec).toString(16).toUpperCase();
	      return numInDec +" / "+"0x"+this.pad(hex, 4);
	  }
	  /**
	   * num here is in hex with 0x
	   */
	  ModbusUtil.prototype.showAddressInDecAndHexFromHex = function(numInHex) {	 
		 var dec = parseInt(numInHex,16);
	     var hex = numInHex.toUpperCase();
	     return dec +" / "+ this.pad(hex, 4);
	 }
	 
	  ModbusUtil.prototype.pad = function(str, max) {
		  str = str.toString();
		  return str.length < max ? this.pad("0" + str, max) : str;
		}
	  
	  
	  ModbusUtil.prototype.showInHex = function(num) {
		  var numStr = num.toString();
		  if(numStr.includes("0x")){
			  numStr = numStr.substring(2);
		  }      
	      return "0x"+this.pad(numStr, 8).toUpperCase(); 
	      
	  }
	  
	  ModbusUtil.prototype.convertAndshowInHex = function(num) {
	      var hex = Number(num).toString(16).toUpperCase();
	      return "0x"+this.pad(hex, 8);
	  }
	  
	  ModbusUtil.prototype.showErrorDiaogOnAddEditPointSameName = function(ptTypeRead,ptName){
			 dialogs.showOk({
				  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
				  content:honIrmControlLex.get('honIrmControlLex.add.edit.same.name',ptName),
				  private: false
				  })
				  .ok(function () {
				    return true;
				  });
			 return true;
		}
	  
	  
	  ModbusUtil.prototype.showErrorDiaogOnAddEditPointOnAdress = function(ptTypeRead,address,ptName){
			 
		    dialogs.showOk({
				  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
				  content:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.address.validation',ptName,address):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.address.validation',ptName,address),
				  private: false
			     })
			     .ok(function () {
				    return true;
				  });
			 return true;
	 }
	  
	  ModbusUtil.prototype.showWarningDialogAndPtsTobeDeleted = function(ptTypeRead){
			 dialogs.showOk({
				  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
				  content:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.no.chkbox.selected'):honIrmControlLex.get('honIrmControlLex.writepoint.no.chkbox.selected'),
				  private: false	  
			       })
				 .ok(function () {
					 return true;
				  });
		 }
	  
	  ModbusUtil.prototype.checkStirngAsNullOrEmpty = function(value){
			if (value == null || value.trim() === ''){
				  return true;
				}
			 return false;
		}
		 

	  return ModbusUtil;
	
});
