
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/ethernetConfiguration',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div>\n	<div>\n		<label id=\"ipAddressTypeLblId\" style = \"padding-right:6px;\">IP Address Type</label>\n		<select id=\"ipAddressTypeSelectId\"></select>  \n	</div>\n	<div style = \"display: inline-block; padding-right:25px;\">\n		<label id=\"ipV4SettingLblId\">IPv4 Settings</label>\n	</div> 	\n	<div style = \"display: inline-block; vertical-align:middle;padding-right:20px;\">\n				<label id=\"enabledLblId\" style=\"padding-right:88px; \">Enabled </label>\n				<input id=\"enabledTextId\" type=\"checkbox\" checked name=true style=\"float:none;\"/>\n			<br>\n				<label id=\"statusLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">Configuration Status</label>\n				<input id=\"statusTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"faultCauseLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">Fault Cause</label>\n				<input id=\"faultCauseTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"ipAddressLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">IP Address</label>\n				<input id=\"ipAddrTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"subnetMaskLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">Subnet Mask</label>\n				<input id=\"subnetMaskTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"defaultGatewayLblId\" style=\"float:left; height:18px; padding-right:5px; margin-top=5px\">Default Gateway</label>\n				<input id=\"defaultGatewayTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n	</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/ethernetConfiguration', t);
return t;
});
/* END_TEMPLATE */
;
/*
Copyright (c) 2021 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
/**
  * Builds a javascript widget that builds property sheet for Ethernet Configuration Slot in IP Configuration
  * @H356559
  */
 
define('nmodule/honIrmConfig/rc/propertysheets/EthernetConfigurationWidget',['baja!',
  'nmodule/webEditors/rc/fe/baja/BaseEditor', 
  'bajaux/mixin/subscriberMixIn',
  'jquery',
  'bajaux/util/SaveCommand',
  'hbs!nmodule/honIrmConfig/rc/templates/ethernetConfiguration'],
  function (      //NOSONAR,
    baja,
    BaseEditor,
    subscriberMixin,
    $,
    SaveCommand,
    template) {
	
	
		
	
	function getIPAddressTypeSelected(dom) {									
		return dom.find('#ipAddressTypeSelectId');
	}
	
	function getEnabledField(dom) {		
		return  dom.find('#enabledTextId');
	}
	
	function getStatusField(dom) {							
		return  dom.find('#statusTextId');
	}
	
	function getFaultCauseField(dom) {							
		return  dom.find('#faultCauseTextId');
	}
    
	function getIpAddressField(dom) {									
		return  dom.find('#ipAddrTextId');
	}
	
	function getSubnetMaskField(dom) {									
		return dom.find('#subnetMaskTextId');
	}
	
	function getDefaultGatewayField(dom) {									
		return dom.find('#defaultGatewayTextId');
	}
	
    /**
    * An editor which helps in editing value
    */
    var EthernetConfigurationWidget = function () {   //NOSONAR
      BaseEditor.apply(this, arguments);
    	//BaseEditor.make(this,arguments);
      subscriberMixin(this);
      this.getCommandGroup().add(new SaveCommand());
      this.ipAddressTypeOptionsObjs = baja.$('honIrmConfig:IPAddressTypeEnum');
      this.dhcp = this.ipAddressTypeOptionsObjs.getEnum().getRange().getOrdinals()[1];
    };

    //extend and set up prototype chain
    EthernetConfigurationWidget.prototype = Object.create(BaseEditor.prototype);
    EthernetConfigurationWidget.prototype.constructor = EthernetConfigurationWidget;

    /**
    * Do initial setup of the DOM for the widget. This will set up the DOM's
    * structure and create a space where the editors would go.
    *
    * @param {jQuery} element the DOM element into which to load this widget
    */
   
    EthernetConfigurationWidget.prototype.doInitialize = function (dom) {
      BaseEditor.prototype.doInitialize.call(this, dom);
      var that = this;      //NOSONAR javascript:S3504
      dom.html(template({
    	  
      })); 
       
      dom.find('select').on('change', function () {
          that.setModified(true);
        });  
      dom.find('input').on('change', function () {
          that.setModified(true);
        });
      dom.find(':text').keydown(function () {
          that.setModified(true);
        });
    };
    
    /**
    * Load the component
    */
    EthernetConfigurationWidget.prototype.doLoad = function (comp) {
  	 var widget = this;
  	 var dom = widget.jq();
 	 loadEthernetConfigurationContent(comp, widget);
	 dom.on("change", "#ipAddressTypeSelectId",widget,function(event){
		     event.preventDefault();
		     changeVisibilityOfEthernetConfigurationFields(widget);
		});
    };
    
	  function changeVisibilityOfEthernetConfigurationFields(widget) {
		  var dom = widget.jq();
		  var ipAddressTypeOption = parseInt(getIPAddressTypeSelected(dom).val());
		  if (ipAddressTypeOption === widget.dhcp) {
			  getIpAddressField(dom).prop("readonly", true);
			  getSubnetMaskField(dom).prop("readonly", true);
			  getDefaultGatewayField(dom).prop("readonly", true);
		  } else {
			  getIpAddressField(dom).prop("readonly", false);
			  getSubnetMaskField(dom).prop("readonly", false);
			  getDefaultGatewayField(dom).prop("readonly", false);
		  }
	  }
    
	  function loadEthernetConfigurationContent(component, widget) {
		  var jsonObj = null;
		  component.getParent().rpc("getEthernetConfigurationValues").then(function(value) {
			  if (value !== undefined) {
				  var dom = widget.jq();
				  jsonObj = JSON.parse(value);
				  var ipAddressTypeEnum = jsonObj.ipAddressTypeEnum;
				  var subnetMaskValue = jsonObj.subnetMaskValue;
				  var ipAddressValue = jsonObj.ipAddressValue;
				  var defaultGatewayValue = jsonObj.defaultGatewayValue;
				  var enabledValue = jsonObj.enabledValue;
				  var statusValue = jsonObj.statusValue;
				  var faultCauseValue = jsonObj.faultCauseValue;
				  var ipAddressTypeOptionsObjs1 = baja.$('honIrmConfig:IPAddressTypeEnum');
				  var ipAddressTypeOptionOrdinal = ipAddressTypeOptionsObjs1.getEnum().getRange().getOrdinals();
				  var option = '';
				  $("#ipAddressTypeSelectId option").remove();
				  for (var i = 0; i < ipAddressTypeOptionOrdinal.length; i++) {
					  var ipAddressTypeOption = ipAddressTypeOptionsObjs1.getEnum().getRange().getDisplayTag(ipAddressTypeOptionOrdinal[i]);
					  option += '<option value="' + ipAddressTypeOptionOrdinal[i] + '">' + ipAddressTypeOption + '</option>';
				  }
				  getIPAddressTypeSelected(dom).append(option);
				  getIPAddressTypeSelected(dom).val(ipAddressTypeEnum.toString());
				  if(Boolean(enabledValue)) {
					getEnabledField(dom).prop("checked", true);
				  } else {
					getEnabledField(dom).prop("checked", false);
				  }
				  getStatusField(dom).val(String(statusValue));
				  getFaultCauseField(dom).val(String(faultCauseValue));
				  getIpAddressField(dom).val(String(ipAddressValue));
				  getSubnetMaskField(dom).val(String(subnetMaskValue));
				  getDefaultGatewayField(dom).val(String(defaultGatewayValue));
				  if (ipAddressTypeEnum === widget.dhcp) {
					  getIpAddressField(dom).prop("readonly", true);
					  getSubnetMaskField(dom).prop("readonly", true);
					  getDefaultGatewayField(dom).prop("readonly", true);
				  } else {
					  getIpAddressField(dom).prop("readonly", false);
					  getSubnetMaskField(dom).prop("readonly", false);
					  getDefaultGatewayField(dom).prop("readonly", false);
				  }
				  getEnabledField(dom).attr('disabled', 'disabled');
				  getEnabledField(dom).attr('readonly', 'readonly');
				  getStatusField(dom).prop("readonly", true);
				  getFaultCauseField(dom).prop("readonly", true);
			  }
		  });
	  }
    
    /**
     * Detach the event handlers when destroying the widget.
     */
    EthernetConfigurationWidget.prototype.doDestroy = function () {
      this.jq().find('input').off();
      this.jq().find('select').off();
    };

    /**
     * Save the user-entered changes to the loaded component.
     *
     * Note that the parameter to this function is the same as that resolved by
     * doRead().
     *
     */
    EthernetConfigurationWidget.prototype.doSave = function (readValue, params) {
     	 var widget = this;
      	 saveEthernetConfigurationContent(readValue, widget);
     };
       
	  function saveEthernetConfigurationContent(component, widget) {
		  var dom = widget.jq();
		  var ethernetConfiguration = { ipAddressTypeEnum: getIPAddressTypeSelected(dom).val(), ipAddressValue: getIpAddressField(dom).val(), subnetMaskValue: getSubnetMaskField(dom).val(), defaultGatewayValue: getDefaultGatewayField(dom).val() };
		  var ethernetConfigurationJSON = JSON.stringify(ethernetConfiguration);
		  component.getParent().rpc("setEthernetConfigurationValues", ethernetConfigurationJSON).then(function(value) {
		  });
		loadEthernetConfigurationContent(component, widget);
	  }
    return EthernetConfigurationWidget;
  });

/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/beatsVAV',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n<div class=\"view_container_beats_vav\">\n\n	<img src=\"/module/honIrmConfig/res/controllerimages/BEATS_VAV.svg\" alt=\"Beats VAV\">\n	\n	<div class=\"terminal_container\" id=\"beats_vav_uio_1\">\n		<select id=\"UIO-1\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_uio_2\">\n		<select id=\"UIO-2\" class=\"terminal_select\">\n		<select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_uio_3\">\n		<select id=\"UIO-3\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_uio_4\">\n		<select id=\"UIO-4\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_uio_5\">\n		<select id=\"UIO-5\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_uio_6\">\n		<select id=\"UIO-6\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_uio_7\">\n		<select id=\"UIO-7\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_ssr_1\">\n		<select id=\"SSR-1\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_ssr_2\">\n		<select id=\"SSR-2\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_ssr_3\">\n		<select id=\"SSR-3\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_ssr_4\">\n		<select id=\"SSR-4\" class=\"terminal_select\">\n		</select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_vav_ssr_5\">\n		<select id=\"SSR-5\" class=\"terminal_select\">\n		</select>\n	</div>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/beatsVAV', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/beatsLarge164424VFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n<div class=\"view_container_beats_fcu_large_1644_24V\">\n\n	<img src=\"/module/honIrmConfig/res/controllerimages/BEATS_LARGE_1644_24V_FCU.svg\" alt=\"Beats Large 1644 24V FCU\">\n	\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_1\">\n		<select id=\"UIO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_2\">\n		<select id=\"UIO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_3\">\n		<select id=\"UIO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_4\">\n		<select id=\"UIO-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_5\">\n		<select id=\"UIO-5\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_6\">\n		<select id=\"UIO-6\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_7\">\n		<select id=\"UIO-7\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_8\">\n		<select id=\"UIO-8\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_9\">\n		<select id=\"UIO-9\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_10\">\n		<select id=\"UIO-10\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_11\">\n		<select id=\"UIO-11\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_12\">\n		<select id=\"UIO-12\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_13\">\n		<select id=\"UIO-13\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_14\">\n		<select id=\"UIO-14\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_15\">\n		<select id=\"UIO-15\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_uio_16\">\n		<select id=\"UIO-16\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ssr_1\">\n		<select id=\"SSR-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ssr_2\">\n		<select id=\"SSR-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ssr_3\">\n		<select id=\"SSR-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ssr_4\">\n		<select id=\"SSR-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ro_1\">\n		<select id=\"RO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ro_2\">\n		<select id=\"RO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ro_3\">\n		<select id=\"RO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_24V_ro_4\">\n		<select id=\"RO-4\" class=\"terminal_select\"></select>\n	</div>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/beatsLarge164424VFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/beatsLarge168424VFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n<div class=\"view_container_beats_fcu_large_1684_24V\">\n\n	<img src=\"/module/honIrmConfig/res/controllerimages/BEATS_LARGE_1684_24V_FCU.svg\" alt=\"Beats Large 1684 24V FCU\">\n	\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_1\">\n		<select id=\"UIO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_2\">\n		<select id=\"UIO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_3\">\n		<select id=\"UIO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_4\">\n		<select id=\"UIO-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_5\">\n		<select id=\"UIO-5\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_6\">\n		<select id=\"UIO-6\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_7\">\n		<select id=\"UIO-7\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_8\">\n		<select id=\"UIO-8\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_9\">\n		<select id=\"UIO-9\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_10\">\n		<select id=\"UIO-10\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_11\">\n		<select id=\"UIO-11\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_12\">\n		<select id=\"UIO-12\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_13\">\n		<select id=\"UIO-13\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_14\">\n		<select id=\"UIO-14\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_15\">\n		<select id=\"UIO-15\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_uio_16\">\n		<select id=\"UIO-16\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_1\">\n		<select id=\"SSR-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_2\">\n		<select id=\"SSR-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_3\">\n		<select id=\"SSR-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_4\">\n		<select id=\"SSR-4\" class=\"terminal_select\"></select>\n	</div>\n\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_5\">\n    	<select id=\"SSR-5\" class=\"terminal_select\"></select>\n    </div>\n    <div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_6\">\n        <select id=\"SSR-6\" class=\"terminal_select\"></select>\n    </div>\n    <div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_7\">\n        <select id=\"SSR-7\" class=\"terminal_select\"></select>\n    </div>\n    <div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ssr_8\">\n        <select id=\"SSR-8\" class=\"terminal_select\"></select>\n    </div>\n\n\n\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ro_1\">\n		<select id=\"RO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ro_2\">\n		<select id=\"RO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ro_3\">\n		<select id=\"RO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1684_24V_ro_4\">\n		<select id=\"RO-4\" class=\"terminal_select\"></select>\n	</div>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/beatsLarge168424VFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/beatsSmall084424VFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n<div class=\"view_container_beats_fcu_small_0844_24V\">\n\n	<img src=\"/module/honIrmConfig/res/controllerimages/BEATS_SMALL_0844_24V_FCU.svg\" alt=\"Beats Small 0844 24V FCU\">\n	\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_1\">\n		<select id=\"UIO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_2\">\n		<select id=\"UIO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_3\">\n		<select id=\"UIO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_4\">\n		<select id=\"UIO-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_5\">\n		<select id=\"UIO-5\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_6\">\n		<select id=\"UIO-6\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_7\">\n		<select id=\"UIO-7\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_uio_8\">\n		<select id=\"UIO-8\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ssr_1\">\n		<select id=\"SSR-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ssr_2\">\n		<select id=\"SSR-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ssr_3\">\n		<select id=\"SSR-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ssr_4\">\n		<select id=\"SSR-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ro_1\">\n		<select id=\"RO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ro_2\">\n		<select id=\"RO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ro_3\">\n		<select id=\"RO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_24V_ro_4\">\n		<select id=\"RO-4\" class=\"terminal_select\"></select>\n	</div>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/beatsSmall084424VFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/compactVAV',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<br> \n<div id=\"mainCont\">\n<div class=\"view_container_compact_vav\">\n\n	<img src=\"/module/honIrmConfig/res/controllerimages/COMPACT_VAV.svg\" alt=\"compactVAV\">\n	\n	<div class=\"terminal_container\" id=\"compact_vav_ui_1\">\n		<select id=\"UI-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ui_2\">\n		<select id=\"UI-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ui_3\">\n		<select id=\"UI-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ui_4\">\n		<select id=\"UI-4\" class=\"terminal_select\"></select>			\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ao_1\">\n		<select id=\"AO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ao_2\">\n		<select id=\"AO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ro_1\">\n		<select id=\"RO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ro_2\">\n		<select id=\"RO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"compact_vav_ro_3\">\n		<select id=\"RO-3\" class=\"terminal_select\"></select>\n	</div>\n</div>	\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/compactVAV', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/irmLargeFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n	<div class=\"view_container_irm_fcu_large\">\n	\n		<img src=\"/module/honIrmConfig/res/controllerimages/IRM_LARGE_FCU.svg\" alt=\"IRM Large FCU\">\n		\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ro_1\">\n			<select id=\"RO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ro_2\">\n			<select id=\"RO-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ro_3\">\n			<select id=\"RO-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ro_4\">\n			<select id=\"RO-4\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_to_1\">\n			<select id=\"TO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_to_2\">\n			<select id=\"TO-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_to_3\">\n			<select id=\"TO-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_to_4\">\n			<select id=\"TO-4\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_1\">\n			<select id=\"UI-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_2\">\n			<select id=\"UI-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_3\">\n			<select id=\"UI-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_4\">\n			<select id=\"UI-4\" class=\"terminal_select\"></select>			\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_5\">\n			<select id=\"UI-5\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_6\">\n			<select id=\"UI-6\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_7\">\n			<select id=\"UI-7\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_8\">\n			<select id=\"UI-8\" class=\"terminal_select\"></select>			\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_9\">\n			<select id=\"UI-9\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ui_10\">\n			<select id=\"UI-10\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ao_1\">\n			<select id=\"AO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ao_2\">\n			<select id=\"AO-2\" class=\"terminal_select\"></select>			\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ao_3\">\n			<select id=\"AO-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ao_4\">\n			<select id=\"AO-4\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ao_5\">\n			<select id=\"AO-5\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_large_ao_6\">\n			<select id=\"AO-6\" class=\"terminal_select\"></select>			\n		</div>\n	</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/irmLargeFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/irmRS4NRS5NFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n	<div class=\"view_container_irm_fcu_small\">\n		\n		<img src=\"/module/honIrmConfig/res/controllerimages/IRM_SMALL_FCU.svg\" alt=\"IRM RS4N RS5N FCU\">\n		\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ro_1\">\n			<select id=\"RO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ro_2\">\n			<select id=\"RO-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ro_3\">\n			<select id=\"RO-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ro_4\">\n			<select id=\"RO-4\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_to_1\">\n			<select id=\"TO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_to_2\">\n			<select id=\"TO-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ui_1\">\n			<select id=\"UI-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ui_2\">\n			<select id=\"UI-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ui_3\">\n			<select id=\"UI-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ui_4\">\n			<select id=\"UI-4\" class=\"terminal_select\"></select>			\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ao_1\">\n			<select id=\"AO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ao_2\">\n			<select id=\"AO-2\" class=\"terminal_select\"></select>			\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ao_3\">\n			<select id=\"AO-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_small_ao_4\">\n			<select id=\"AO-4\" class=\"terminal_select\"></select>\n		</div>\n	</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/irmRS4NRS5NFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/irmRS3NFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n	<div class=\"view_container_irm_fcu_rs3n\">\n		\n		<img src=\"/module/honIrmConfig/res/controllerimages/IRM_SMALL_FCU.svg\" alt=\"IRM RS3N FCU\">\n		\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_ro_1\">\n			<select id=\"RO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_ro_2\">\n			<select id=\"RO-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_ro_3\">\n			<select id=\"RO-3\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_to_1\">\n			<select id=\"TO-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_to_2\">\n			<select id=\"TO-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_ui_1\">\n			<select id=\"UI-1\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_ui_2\">\n			<select id=\"UI-2\" class=\"terminal_select\"></select>\n		</div>\n		<div class=\"terminal_container\" id=\"irm_fcu_rs3n_ui_3\">\n			<select id=\"UI-3\" class=\"terminal_select\"></select>\n		</div>\n	</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/irmRS3NFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/beatsLarge1644230VFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n<div class=\"view_container_beats_fcu_large_1644_230V\">\n\n	<img src=\"/module/honIrmConfig/res/controllerimages/BEATS_LARGE_1644_230V_FCU.svg\" alt=\"Beats Large 1644 230V FCU\">\n	\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_1\">\n		<select id=\"UIO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_2\">\n		<select id=\"UIO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_3\">\n		<select id=\"UIO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_4\">\n		<select id=\"UIO-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_5\">\n		<select id=\"UIO-5\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_6\">\n		<select id=\"UIO-6\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_7\">\n		<select id=\"UIO-7\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_8\">\n		<select id=\"UIO-8\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_9\">\n		<select id=\"UIO-9\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_10\">\n		<select id=\"UIO-10\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_11\">\n		<select id=\"UIO-11\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_12\">\n		<select id=\"UIO-12\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_13\">\n		<select id=\"UIO-13\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_14\">\n		<select id=\"UIO-14\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_15\">\n		<select id=\"UIO-15\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_uio_16\">\n		<select id=\"UIO-16\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_co_1\">\n		<select id=\"CO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_co_2\">\n		<select id=\"CO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_co_3\">\n		<select id=\"CO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_co_4\">\n		<select id=\"CO-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_ro_1\">\n		<select id=\"RO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_ro_2\">\n		<select id=\"RO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_ro_3\">\n		<select id=\"RO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_large_1644_230V_ro_4\">\n		<select id=\"RO-4\" class=\"terminal_select\"></select>\n	</div>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/beatsLarge1644230VFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/beatsSmall0844230VFCU',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div id=\"mainCont\">\n<div class=\"view_container_beats_fcu_small_0844_230V\">\n\n	<img src=\"/module/honIrmConfig/res/controllerimages/BEATS_SMALL_0844_230V_FCU.svg\" alt=\"Beats Small 0844 230V FCU\">\n	\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_1\">\n		<select id=\"UIO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_2\">\n		<select id=\"UIO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_3\">\n		<select id=\"UIO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_4\">\n		<select id=\"UIO-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_5\">\n		<select id=\"UIO-5\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_6\">\n		<select id=\"UIO-6\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_7\">\n		<select id=\"UIO-7\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_uio_8\">\n		<select id=\"UIO-8\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_co_1\">\n		<select id=\"CO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_co_2\">\n		<select id=\"CO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_co_3\">\n		<select id=\"CO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_co_4\">\n		<select id=\"CO-4\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_ro_1\">\n		<select id=\"RO-1\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_ro_2\">\n		<select id=\"RO-2\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_ro_3\">\n		<select id=\"RO-3\" class=\"terminal_select\"></select>\n	</div>\n	<div class=\"terminal_container\" id=\"beats_fcu_small_0844_230V_ro_4\">\n		<select id=\"RO-4\" class=\"terminal_select\"></select>\n	</div>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/beatsSmall0844230VFCU', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/terminalAssignmentView',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var stack1, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div>\n"
    + ((stack1 = lookupProperty(helpers,"if").call(depth0 != null ? depth0 : (container.nullContext || {}),(depth0 != null ? lookupProperty(depth0,"errorText") : depth0),{"name":"if","hash":{},"fn":container.program(1, data, 0),"inverse":container.program(3, data, 0),"data":data,"loc":{"start":{"line":2,"column":1},"end":{"line":15,"column":8}}})) != null ? stack1 : "")
    + "</div>\n";
},"1":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "		<div class=\"error_msg_container\">\n			"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"errorText") || (depth0 != null ? lookupProperty(depth0,"errorText") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"errorText","hash":{},"data":data,"loc":{"start":{"line":4,"column":3},"end":{"line":4,"column":16}}}) : helper)))
    + "\n		</div>\n";
},"3":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "		<div id=\"buttons_cont\">\n			<button id=\"zoomOut\"><img src=\"/module/honIrmConfig/res/zoomimages/zoomOut.svg\" id=\"zoomOutImage\" alt=\"Zoom Out\" title=\"Zoom Out\"></button>\n			<button id=\"zoomIn\"><img src=\"/module/honIrmConfig/res/zoomimages/zoomIn.svg\" id=\"zoomInImage\" alt=\"Zoom In\" title=\"Zoom In\"></button>\n			<button id=\"defaultZoom\"><img src=\"/module/honIrmConfig/res/zoomimages/defaultZoom.svg\" id=\"defaultZoomImage\" alt=\"Reset Zoom\" title=\"Reset Zoom\"></button>\n			<input type=\"number\" id=\"customZoom\" title=\"Custom Zoom\" value=\"100\"/>\n			<label id=\"percenter_cont\">%</label>\n		</div>\n		"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"showTerminalAssignment") || (depth0 != null ? lookupProperty(depth0,"showTerminalAssignment") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"showTerminalAssignment","hash":{},"data":data,"loc":{"start":{"line":14,"column":2},"end":{"line":14,"column":28}}}) : helper)))
    + "\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/terminalAssignmentView', t);
return t;
});
/* END_TEMPLATE */
;
/*
Copyright (c) 2021 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/

/**
  * Builds a javascript widget that builds Terminal assignment view
  * @H356559
  */

define('nmodule/honIrmConfig/rc/terminalviews/TerminalAssignment',['baja!',
	'nmodule/webEditors/rc/fe/baja/BaseEditor',
	'bajaux/mixin/subscriberMixIn',
	'jquery',
	'bajaux/util/SaveCommand',
	'Handlebars',
	'hbs!nmodule/honIrmConfig/rc/templates/beatsVAV',
	'hbs!nmodule/honIrmConfig/rc/templates/beatsLarge164424VFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/beatsLarge168424VFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/beatsSmall084424VFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/compactVAV',
	'hbs!nmodule/honIrmConfig/rc/templates/irmLargeFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/irmRS4NRS5NFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/irmRS3NFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/beatsLarge1644230VFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/beatsSmall0844230VFCU',
	'hbs!nmodule/honIrmConfig/rc/templates/terminalAssignmentView',
	'dialogs',
	'lex!honIrmConfig',
	'Promise',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/beatsVAV',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/beatsLarge164424VFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/beatsLarge168424VFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/beatsSmall084424VFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/compactVAV',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/irmLargeFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/irmRS4NRS5NFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/irmRS3NFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/beatsLarge1644230VFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/beatsSmall0844230VFCU',
	'css!nmodule/honIrmConfig/rc/css/terminalassignmentview/terminalAssignmentView'],
	function(      //NOSONAR
		baja,
		BaseEditor,
		subscriberMixin,
		$,
		SaveCommand,
		Handlebars,
		beatsVAV,
		beatsLarge164424VFCU,
	    beatsLarge168424VFCU,
		beatsSmall084424VFCU,
		compactVAV,
		irmLargeFCU,
		irmRS4NRS5NFCU,
		irmRS3NFCU,
		beatsLarge1644230VFCU,
		beatsSmall0844230VFCU,
		terminalAssignmentView,
		dialogs,
		lexicons) {

		

		var honIrmConfigLex = lexicons[0];
		var terminals = [];
		var changedItems = baja.$('baja:Component');
		var unassigned = "Unassigned";
		var underDevelopment = 0;
		var jobInProgress = 1;
		var migrationPending = 2;
		var invalidModel = 3;
		var invalidBrand = 4;
		var notSupported = 5;
		var beatsVAVTemplate = "beatsVAV";
		var beatsLarge164424VFCUTemplate = "beatsLarge164424VFCU";
		var beatsSmall084424VFCUTemplate = "beatsSmall084424VFCU";
		var beatsLarge168424VFCUTemplate = "beatsLarge168424VFCU";
		var compactVAVTemplate = "compactVAV";
		var irmLargeFCUTemplate = "irmLargeFCU";
		var irmRS4NRS5NFCUTemplate = "irmRS4NRS5NFCU";
		var irmRS3NFCUTemplate = "irmRS3NFCU";
		var beatsLarge1644230VFCUTemplate = "beatsLarge1644230VFCU";
		var beatsSmall0844230VFCUTemplate = "beatsSmall0844230VFCU";
		var zoomClicks = 0;
		var minZoomClicks = -3;
		var maxZoomClicks = 10;
		var defaultZoomLevel = 100;
		var dropDownReferencePxSize;
		var sub = new baja.Subscriber();
		
		/**
		* An editor which helps in editing value
		*/
		var TerminalAssignment = function() {   //NOSONAR
			BaseEditor.apply(this, arguments);
			subscriberMixin(this);
			this.getCommandGroup().add(new SaveCommand());

			Handlebars.registerHelper("showTerminalAssignment", function(type) {
				console.log("type to show " + type.data.root.type);
				if (type.data.root.type === beatsVAVTemplate) {
					return new Handlebars.SafeString(beatsVAV({}));
				} else if (type.data.root.type === beatsLarge164424VFCUTemplate) {
					return new Handlebars.SafeString(beatsLarge164424VFCU({}));
				} else if (type.data.root.type === beatsSmall084424VFCUTemplate) {
					return new Handlebars.SafeString(beatsSmall084424VFCU({}));
				} else if (type.data.root.type === compactVAVTemplate) {
					return new Handlebars.SafeString(compactVAV({}));
				} else if (type.data.root.type === irmLargeFCUTemplate) {
					return new Handlebars.SafeString(irmLargeFCU({}));
				} else if (type.data.root.type === irmRS4NRS5NFCUTemplate) {
					return new Handlebars.SafeString(irmRS4NRS5NFCU({}));
				} else if (type.data.root.type === irmRS3NFCUTemplate) {
					return new Handlebars.SafeString(irmRS3NFCU({}));
				} else if (type.data.root.type === beatsLarge1644230VFCUTemplate) {
					return new Handlebars.SafeString(beatsLarge1644230VFCU({}));
				} else if (type.data.root.type === beatsSmall0844230VFCUTemplate) {
					return new Handlebars.SafeString(beatsSmall0844230VFCU({}));
				} else if (type.data.root.type === beatsLarge168424VFCUTemplate) {
				    return new Handlebars.SafeString(beatsLarge168424VFCU({}));
				}
			});
		};

		//extend and set up prototype chain
		TerminalAssignment.prototype = Object.create(BaseEditor.prototype);
		TerminalAssignment.prototype.constructor = TerminalAssignment;

		/**
		* Load the component.
		* Update the terminal Assignement view with the correct HBS file based on response from Server side.
		* Fetch IO Terminal Details from ServerSide based on model and update the details to the dropdown.
		* Subscribe all the Terminals for changed callback.
		*/
		TerminalAssignment.prototype.doLoad = function(comp) {
			var widget = this;
			var dom = widget.jq();
			BaseEditor.prototype.doInitialize.call(this, dom);
			zoomClicks = 0;
			var clickEvent = ['#zoomIn','#zoomOut','#defaultZoom'];
			dom.on("click", clickEvent, widget, function(event) {
				event.preventDefault();
				if (this.id == "zoomIn" && zoomClicks < maxZoomClicks) {
					zoomClicks++;
				} else if (this.id == "zoomOut" && zoomClicks > minZoomClicks) {
					zoomClicks--;
				} else if (this.id == "defaultZoom") {
					zoomClicks = 0;
				}
				setStagedZoom();
			});
			dom.on("keypress", '#customZoom', widget, function(event) {
				if (event.keyCode == 13) {
					event.preventDefault();
					var customZoom = document.getElementById('customZoom');
					setUserZoom(customZoom);
				}
			});
			var result = updateTerminalAssignmentViewAndGetDeviceDetails(comp, dom);
			if (result.$val !== underDevelopment && result.$val !== jobInProgress && result.$val !== migrationPending && result.$val !== invalidBrand && result.$val !== invalidModel && result.$val !== notSupported) {
				getIOTerminalDetails(comp).then(function(ioTerminalPropResult) {
					(loadIOTerminalDropdown(ioTerminalPropResult, dom)).then(subscribeToChangedCallBack(dom, widget)).catch(function(err) {
						return Promise.reject(err);
					});
				}).catch(function(err) {
					return Promise.reject(err);
				});
			}
			sub.attach('changed', function(prop) {
		 		if (prop.getName() === 'isTerminalSaveInProgress') { 
		 		enableOrDisableTheDropDown(prop.$display); 
		 		}
	 		});
	 			 var ord = 'station:|' + comp.getSlotPath();
	 			 baja.Ord.make(ord).get({ subscriber: sub }).then(enableOrDisableTheDropDown);
		};
		
		function enableOrDisableTheDropDown(enableOrDisable){
			for (var index in terminals){
				if (index == "contains") {
						return false;
				}
				var terminal = document.getElementById(terminals[index]);
				if(enableOrDisable === "true"){
					terminal.disabled=true;
				}else{
					terminal.disabled=false;
				}
			}
		}

		function setStagedZoom() {
			var zoomLevel = (defaultZoomLevel + (zoomClicks * 10));
			setZoomLevel(zoomLevel);
			var customZoom = document.getElementById('customZoom');
			customZoom.value = (defaultZoomLevel + (zoomClicks * 10));
		}
		
		function setZoomLevel(zoomLevel) {
			var terminalAssignmentContentView = document.getElementById('mainCont');
			terminalAssignmentContentView.style.width = zoomLevel + "%";
			terminalAssignmentContentView.style.position = "relative";
			terminalAssignmentContentView.style.right = (zoomClicks * 4) + "%";
			for (var index in terminals) {
				if (index == "contains") {
					return false;
				}
				var terminal = document.getElementById(terminals[index]);
				terminal.style.fontSize = (dropDownReferencePxSize + (zoomClicks * 0.8)) + "px";
				terminal.style.verticalAlign = "-" + (zoomClicks * 5) + "%";
			}
		}
		
		function setUserZoom(customZoom) {
			var maxZoomLevel = 200;
			var minZoomLevel = 70;
			if (typeof (customZoom.val == 'number')) {
				if (customZoom.value > maxZoomLevel) {
					zoomClicks = maxZoomClicks;
					customZoom.value = maxZoomLevel;
					setZoomLevel(maxZoomLevel);
				} else if (customZoom.value < minZoomLevel) {
					zoomClicks = minZoomClicks;
					customZoom.value = minZoomLevel;
					setZoomLevel(minZoomLevel);
				} else {
					zoomClicks = Math.round((customZoom.value - defaultZoomLevel) / 10);
					setZoomLevel(customZoom.value);
				}
			} else {
				customZoom.value = (zoomClicks * 10) + defaultZoomLevel;
			}
		}
		
		/**
		* Find and @returns the JQuery element based on the DOM & terminalName
		*/
		function getCorrespondingIOTerminal(dom, terminalName) {
			var term = '#' + terminalName;
			return dom.find(term);
		}

		/**
		* Append the terminalName with '#'.
		* @returns
		*/
		function getCorrespondingTerminalId(terminalName) {
			return ('#' + terminalName);
		}

		/**
		* Query the server side for the device model details and update and the corresponding view based on the response.
		* @returns the result from ServerSide once the operation is complete for further processing.
		*/
		function updateTerminalAssignmentViewAndGetDeviceDetails(comp, dom) {
			var terminalServerSideclassName = "honIrmConfig:TerminalAssignmentServerSideCallHandler";
			var modelDetails = "getCurrentDeviceModelDetails";

			return comp.serverSideCall({
				typeSpec: terminalServerSideclassName,
				methodName: modelDetails
			})
				.then(function(propResult) {	
					console.log("propResult: " + propResult.$val);
					var errorText; 
					if (propResult.$val === underDevelopment) {
						errorText = new Handlebars.SafeString(honIrmConfigLex.get('honIrmConfigLex.under.development'));
					} else if (propResult.$val === jobInProgress) {
						errorText = new Handlebars.SafeString(honIrmConfigLex.get('honIrmConfigLex.job.in.progress'));
					} else if (propResult.$val === migrationPending) {
						errorText = new Handlebars.SafeString(honIrmConfigLex.get('honIrmConfigLex.migration.pending'));
					} else if (propResult.$val === invalidBrand) {
						errorText = new Handlebars.SafeString(honIrmConfigLex.get('honIrmConfigLex.invalid.brand'));
					} else if (propResult.$val === invalidModel) {
						errorText = new Handlebars.SafeString(honIrmConfigLex.get('honIrmConfigLex.invalid.model'));
					} else if (propResult.$val === notSupported) {
						errorText = new Handlebars.SafeString(honIrmConfigLex.get('honIrmConfigLex.not.supported'));
					}

					loadTerminalAssignmentView(errorText, dom, propResult)
					return propResult;
				})
				.catch(function(err) {
					return Promise.reject(err);
				});
		}
		
		function loadTerminalAssignmentView(errorText, dom, propResult) {
			var beatsVAVController = 6;
			var beatsLarge164424VFCUController = 7;
			var beatsSmall084424VFCUController = 8;
			var compactVAVController = 9;
			var irmLargeFCUController = 10;
			var irmRS4NRS5NFCUController = 11;
			var irmRS3NFCUController = 12;
			var beatsLarge1644230VFCUController = 13;
			var beatsSmall0844230VFCUController = 14;
			var beatsLarge168424VFCUController = 15;

			
			if (errorText) {
				dom.html(terminalAssignmentView({
					errorText: errorText
				}));
			} else if (propResult.$val === beatsVAVController) {
				dom.html(terminalAssignmentView({ type: beatsVAVTemplate }));
			} else if (propResult.$val === beatsLarge164424VFCUController) {
				dom.html(terminalAssignmentView({ type: beatsLarge164424VFCUTemplate }));
			} else if (propResult.$val === beatsSmall084424VFCUController) {
				dom.html(terminalAssignmentView({ type: beatsSmall084424VFCUTemplate }));
			} else if (propResult.$val === compactVAVController) {
				dom.html(terminalAssignmentView({ type: compactVAVTemplate }));
			} else if (propResult.$val === irmLargeFCUController) {
				dom.html(terminalAssignmentView({ type: irmLargeFCUTemplate }));
			} else if (propResult.$val === irmRS4NRS5NFCUController) {
				dom.html(terminalAssignmentView({ type: irmRS4NRS5NFCUTemplate }));
			} else if (propResult.$val === irmRS3NFCUController) {
				dom.html(terminalAssignmentView({ type: irmRS3NFCUTemplate }));
			} else if (propResult.$val === beatsLarge1644230VFCUController) {
				dom.html(terminalAssignmentView({ type: beatsLarge1644230VFCUTemplate }));
			} else if (propResult.$val === beatsSmall0844230VFCUController) {
				dom.html(terminalAssignmentView({ type: beatsSmall0844230VFCUTemplate }));
			} else if (propResult.$val === beatsLarge168424VFCUController){
			    dom.html(terminalAssignmentView({ type: beatsLarge168424VFCUTemplate }));
			}
		}
		
		/**
		* Query the server side for the the terminal details supported by the current model.
		* @returns the result from ServerSide as a promise.
		*/
		function getIOTerminalDetails(comp) {
			var terminalServerSideclassName = "honIrmConfig:TerminalAssignmentServerSideCallHandler";
			var supportedFBNamesForTerminals = "getFunctionBlockNameSupportedForEachTerminal";

			return comp.serverSideCall({
				typeSpec: terminalServerSideclassName,
				methodName: supportedFBNamesForTerminals
			})
				.then(function(ioTerminalPropResult) {
					return Promise.resolve(ioTerminalPropResult);
				})
				.catch(function(err) {
					return Promise.reject(err);
				});
		}

		/**
		* Based on the ioTerminalPropResult, load all the dropdowns supported by the model
		* @returns a promise to confirm the completion of the operation.
		*/
		function loadIOTerminalDropdown(ioTerminalPropResult, dom) {
			terminals.length = 0;
			if (ioTerminalPropResult.getSlots().properties().is("baja:Component")) {
				ioTerminalPropResult.getSlots().dynamic().properties().each(function(terminalId) {
					var option = '';
					var terms = baja.SlotPath.unescape(terminalId.$slotName);
					var propName = terms.split("~");
					var term = propName[0];
					var initialSelection = propName[1];
					var termValue = terminalId.$val;
					terminals.push(term);
					var removeOption = '#' + term + ' option';
					$(removeOption).remove();
					option += '<option value=' + unassigned + '>' + unassigned + '</option>';
					if (termValue.getSlots().properties().is("baja:Component")) {
						termValue.getSlots().dynamic().properties().each(function(functionBlockList) {
							var dropDownAdd = baja.SlotPath.unescape(functionBlockList.$slotName);
							option += '<option value="' + dropDownAdd + '">' + dropDownAdd + '</option>';
						});
					} else {
						return Promise.reject(honIrmConfigLex.get('honIrmConfigLex.not.component'));
					}
					var ioTemrinal = getCorrespondingIOTerminal(dom, term);
					ioTemrinal.append(option);
					ioTemrinal.val(initialSelection);
				});
				var dropDownDivs = document.getElementsByClassName('terminal_container');
				var dropDownDivSize = window.getComputedStyle(dropDownDivs[0], null).getPropertyValue('font-size');
				var dropDownPxSizeInString = dropDownDivSize.split("px");
				dropDownReferencePxSize = parseInt(dropDownPxSizeInString);
				return Promise.resolve();
			}
			return Promise.reject(honIrmConfigLex.get('honIrmConfigLex.not.component'));
		}

		/**
		* Loop through all the terminals supported for the current model and add the subscription for 'Changed' & 'Click'
		* @returns a promise to confirm the completion of the operation.
		*/
		function subscribeToChangedCallBack(dom, widget) {
			for (var index in terminals) {
				if (index === "contains") {
					return;
				}
				var changedTerminal = getCorrespondingTerminalId(terminals[index]);
				var previousSelection;
				dom.on("click", changedTerminal, widget, function(event) {
					event.preventDefault();
					previousSelection = dom.find(this)[0].value;
					console.log("terminal before change " + previousSelection);
				});
				dom.on("change", changedTerminal, widget, function(event) {
					event.preventDefault();
					var currentSelection = dom.find(this)[0].value;
					console.log("terminal has been changed " + currentSelection);
					var isDuplicate = isDuplicateFound(dom, this, currentSelection, previousSelection);
					console.log("terminal has been changed " + isDuplicate);
					widget.setModified(true);
				});
			}
			return Promise.resolve();
		}

		/**
		* Loop through all the terminals supported for the current model and check if the 'previousSelection' is present
		* in any other terminal Dropdown. If present, then update 'previousSelection' in the other terminal.
		* else ask the user for confirmation to proceed with swap ot to revert the swapping. 
		* @returns True if Duplicate is found else false.
		*/
		function isDuplicateFound(dom, changedElement, currentSelection, previousSelection) {
			for (var index in terminals) {
				if (index === "contains") {
					return false;
				}
				var otherElement = terminals[index];
				if (changedElement.id === otherElement) {
					continue;
				}
				var termId = getCorrespondingTerminalId(otherElement);
				var existing = dom.find(termId)[0].value;
				if (existing === currentSelection && currentSelection !== unassigned) {
					// Check "previousSelection" is present in the drop down then set it as previousSelection otherwise set it as unassigned.
					if (isFunctionBlockExistsInDropDown(termId, previousSelection)) {
						console.log(previousSelection + " Option exists in " + otherElement.name);
						getCorrespondingIOTerminal(dom, otherElement).val(previousSelection);
					} else {
						console.log(previousSelection + " Option doesn't exists in " + otherElement.name);
						confirmAndRevertToOldValueBasedonUserConfirmation(dom, otherElement, changedElement, previousSelection);
					}
					return true;
				}
			}
			return false;
		}

		/**
		* Check if 'previousSelection' is present as an option in other terminal.
		* @returns true if previousSelection existing in the terminal else false.
		*/
		function isFunctionBlockExistsInDropDown(terminalId, previousSelection) {
			var exists = false;
			$(terminalId + ' option').each(function() {
				if (this.value === previousSelection) {
					exists = true;
				}
			});
			return exists;
		}
		
		/**
		* Update All the Terminal details in the component
		*/
		function updateDetailsOfTerminalInComponent() {
			for (var index in terminals) {
				if (index === "contains") {
					return;
				}
				var terminalPin = terminals[index];
				var terminalPinName = baja.SlotPath.escape(terminalPin);
				var functionBlockName = $(getCorrespondingTerminalId(terminalPin)).find(":selected").text();
				if (null !== changedItems.getSlot(terminalPinName)) {
					changedItems.remove(terminalPinName);
				}
				changedItems.add({
					slot: terminalPinName,
					value: functionBlockName,
				}).then(function(prop) {
					baja.outln('added a new Property named "' + prop + '"');
				})
					.catch(function(err) {
						baja.error('error adding Property: ' + err);
					});
			}
		}

		/**
		* Ask the user for confirmation on whether to proceed with marking 'otherElement' as Unassigned or update
		* 'changedElement' to the 'previousSelection'.
		*/
		function confirmAndRevertToOldValueBasedonUserConfirmation(dom, otherElement, changedElement, previousSelection) {
			dialogs.showYesNo({
				title: honIrmConfigLex.get('honIrmConfigLex.characteristic.not.supported.title'),
				content: honIrmConfigLex.get('honIrmConfigLex.characteristic.not.supported.content', previousSelection, otherElement),
				private: false
			})
				.yes(function() {
					console.log("Yes option clicked. Setting " + otherElement + " as unassigned");
					getCorrespondingIOTerminal(dom, otherElement).val(unassigned);
				}).no(function() {
					console.log("No option clicked. Reverting " + changedElement.id + " to " + previousSelection);
					dom.find(changedElement).val(previousSelection);
				});
		}


		/**
		* Save the component
		*/
		TerminalAssignment.prototype.doSave = function(comp) {
			var widget =this;
			updateDetailsOfTerminalInComponent();
			sendChangedDetailsToServerSide(comp, widget);
			changedItems = baja.$('baja:Component');
		};

		/**
		* Send the changes made by the user to the ServerSide as a BComponent.
		*/
		function sendChangedDetailsToServerSide(comp, widget) {
			var terminalServerSideclassName = "honIrmConfig:TerminalAssignmentServerSideCallHandler";
			var saveChangedDetails = "saveChangedTerminalAndRespond";

			return comp.serverSideCall({
				typeSpec: terminalServerSideclassName,
				methodName: saveChangedDetails,
				value: changedItems
			})
				.then(function(result) {
					console.log(result);
					handleResultFromServerSide(result, widget);
				})
				.catch(function(err) {
					return Promise.reject(err);
				});
		}

		/**
		* Based on the 'result'. Either show it to the user or not. If result is null don't show to user.'
		*/
		function handleResultFromServerSide(result, widget) {
			if (null !== result) {
				dialogs.showOk({
					title: honIrmConfigLex.get('honIrmConfigLex.error.saving.title'),
					content: result,
					private: false
				})
					.ok(function() {
						widget.setModified(true);
						console.log("OK option clicked.");
					});
			}
		}

		return TerminalAssignment;
	});

/* START_TEMPLATE */
define('hbs!nmodule/honIrmConfig/rc/templates/wifiConfiguration',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div>\n	<div style = \"display: inline-block; vertical-align:middle;padding-right:20px;\">\n			<br>\n				<label id=\"statusLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">Configuration Status</label>\n				<input id=\"wifiStatusTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"faultCauseLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">Fault Cause</label>\n				<input id=\"wifiFaultCauseTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"wifiSSIDLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">WiFi SSID</label>\n				<input id=\"wifiSSIDTextId\" type=\"text\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"passwordLblId\" style=\"float:left; height:18px; padding-right:10px; margin-top=5px\">Password</label>\n				<input id=\"passwordTextId\" type=\"password\" value=\"\" size=\"50\" style=\"float:right; height:18px; margin-top=5px\"></input>\n			<br>\n				<label id=\"wifiSecurityTypeLblId\" style = \"padding-right:6px;\">Security</label>\n				<select id=\"wifiSecurityTypeSelectId\" style=\"margin-left:83px\"></select>  \n			<br>\n	</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmConfig/rc/templates/wifiConfiguration', t);
return t;
});
/* END_TEMPLATE */
;
/*
Copyright (c) 2022 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
/**
  * Builds a javascript widget that builds property sheet for WiFi Configuration Slot in IP Configuration
  * @H356559
  */
 
define('nmodule/honIrmConfig/rc/propertysheets/WiFiConfigurationWidget',['baja!',
  'nmodule/webEditors/rc/fe/baja/BaseEditor', 
  'bajaux/mixin/subscriberMixIn',
  'jquery',
  'bajaux/util/SaveCommand',
  'hbs!nmodule/honIrmConfig/rc/templates/wifiConfiguration'],
  function (      //NOSONAR,
    baja,
    BaseEditor,
    subscriberMixin,
    $,
    SaveCommand,
    template) {
	
	
		
	var sub = new baja.Subscriber();
	
	function getWiFiSecurityTypeSelected(dom) {									
		return dom.find('#wifiSecurityTypeSelectId');
	}
	
	function getStatusField(dom) {							
		return  dom.find('#wifiStatusTextId');
	}
	
	function getFaultCauseField(dom) {							
		return  dom.find('#wifiFaultCauseTextId');
	}
    
	function getWiFiSSIDField(dom) {									
		return  dom.find('#wifiSSIDTextId');
	}
	
	function getPasswordField(dom) {									
		return dom.find('#passwordTextId');
	}
	
    /**
    * An editor which helps in editing value
    */
    var WiFiConfigurationWidget = function () {   //NOSONAR
      BaseEditor.apply(this, arguments);
    	//BaseEditor.make(this,arguments);
      subscriberMixin(this);
      this.getCommandGroup().add(new SaveCommand());
      this.wifiSecurityTypeOptionsObjs = baja.$('honIrmConfig:WIFISecurityTypeEnum');
      this.open = this.wifiSecurityTypeOptionsObjs.getEnum().getRange().getOrdinals()[0];
    };

    //extend and set up prototype chain
    WiFiConfigurationWidget.prototype = Object.create(BaseEditor.prototype);
    WiFiConfigurationWidget.prototype.constructor = WiFiConfigurationWidget;

    /**
    * Do initial setup of the DOM for the widget. This will set up the DOM's
    * structure and create a space where the editors would go.
    *
    * @param {jQuery} element the DOM element into which to load this widget
    */
   
    WiFiConfigurationWidget.prototype.doInitialize = function (dom) {
      BaseEditor.prototype.doInitialize.call(this, dom);
      var that = this;      //NOSONAR javascript:S3504
      dom.html(template({
    	  
      })); 
       
      dom.find('select').on('change', function () {
          that.setModified(true);
        });  
      dom.find('input').on('change', function () {
          that.setModified(true);
        });
      dom.find(':text').keydown(function () {
          that.setModified(true);
        });
      dom.find(':password').keydown(function () {
          that.setModified(true);
        });

    };

    /**
    * Load the component
    */
    WiFiConfigurationWidget.prototype.doLoad = function (comp) {
  	 var widget = this;
  	 var dom = widget.jq();
	 sub.attach('changed', function(prop) {
		 if (prop.getName() === 'faultCause') { loadWiFiConfigurationContent(prop.$complex, widget); }
	 });
	 var ord = 'station:|' + comp.getSlotPath();
	 baja.Ord.make(ord).get({ subscriber: sub }).then(loadWiFiConfigurationContent);
 	 loadWiFiConfigurationContent(comp, widget);
	 dom.on("change", "#wifiSecurityTypeSelectId",widget,function(event){
		     event.preventDefault();
		     changeVisibilityOfWiFiConfigurationFields(widget);
		});
    };
    
	  function changeVisibilityOfWiFiConfigurationFields(widget) {
		  var dom = widget.jq();
		  var wifiSecurityTypeOption = parseInt(getWiFiSecurityTypeSelected(dom).val());
		  if (wifiSecurityTypeOption === widget.open) {
			  getPasswordField(dom).prop("readonly", true);
		  } else {
			  getPasswordField(dom).prop("readonly", false);
		  }
	  }
    
	  function loadWiFiConfigurationContent(component, widget) {
		  var jsonObj = null;
		  component.getParent().rpc("getWiFiConfigurationValues").then(function(value) {
			  if (value !== undefined) {
				  var dom = widget.jq();
				  jsonObj = JSON.parse(value);
				  var wifiSecurityTypeEnum = jsonObj.wifiSecurityTypeEnum;
				  var statusValue = jsonObj.statusValue;
				  var faultCauseValue = jsonObj.faultCauseValue;
				  var ssidValue = jsonObj.wifiSSID;
				  var passwordValue = jsonObj.wifiPassword;
				  var wifiSecurityTypeOptionsObjs1 = baja.$('honIrmConfig:WIFISecurityTypeEnum');
				  var wifiSecurityTypeOptionOrdinal = wifiSecurityTypeOptionsObjs1.getEnum().getRange().getOrdinals();
				  var option = '';
				  $("#wifiSecurityTypeSelectId option").remove();
				  for (var i = 0; i < wifiSecurityTypeOptionOrdinal.length; i++) {
					  if (i === 3) {
						  continue;
					  }
					  var wifiSecurityTypeOption = wifiSecurityTypeOptionsObjs1.getEnum().getRange().getDisplayTag(wifiSecurityTypeOptionOrdinal[i]);
					  option += '<option value="' + wifiSecurityTypeOptionOrdinal[i] + '">' + wifiSecurityTypeOption + '</option>';
				  }
				  getWiFiSecurityTypeSelected(dom).append(option);
				  getWiFiSecurityTypeSelected(dom).val(wifiSecurityTypeEnum.toString());
				  getStatusField(dom).val(String(statusValue));
				  getFaultCauseField(dom).val(String(faultCauseValue));
				  getWiFiSSIDField(dom).val(String(ssidValue));
				  getPasswordField(dom).val(String(passwordValue));
				  if (wifiSecurityTypeEnum === widget.open) {
					  getPasswordField(dom).prop("readonly", true);
				  } else {
					  getPasswordField(dom).prop("readonly", false);
				  }
				  getStatusField(dom).prop("readonly", true);
				  getFaultCauseField(dom).prop("readonly", true);
			  }
		  });
	  }
    
    /**
     * Detach the event handlers when destroying the widget.
     */
    WiFiConfigurationWidget.prototype.doDestroy = function () {
	  sub.unsubscribeAll();
      sub.detach();
      this.jq().find('input').off();
      this.jq().find('select').off();
    };

    /**
     * Save the user-entered changes to the loaded component.
     *
     * Note that the parameter to this function is the same as that resolved by
     * doRead().
     *
     */
    WiFiConfigurationWidget.prototype.doSave = function (readValue, params) {
     	 var widget = this;
      	 saveWiFiConfigurationContent(readValue, widget);
     };
       
	  function saveWiFiConfigurationContent(component, widget) {
		  var dom = widget.jq();
		  var wifiConfiguration = { wifiSecurityTypeEnum: getWiFiSecurityTypeSelected(dom).val(), wifiSSID: getWiFiSSIDField(dom).val(), wifiPassword: getPasswordField(dom).val() };
		  var wifiConfigurationJSON = JSON.stringify(wifiConfiguration);
		  component.getParent().rpc("setWiFiConfigurationValues", wifiConfigurationJSON).then(function(value) {
		  });
	  }
    return WiFiConfigurationWidget;
  });


require(['nmodule/honIrmConfig/rc/propertysheets/EthernetConfigurationWidget','nmodule/honIrmConfig/rc/terminalviews/TerminalAssignment', 'nmodule/honIrmConfig/rc/propertysheets/WiFiConfigurationWidget'], function (EthernetConfigurationWidget, TerminalAssignment, WiFiConfigurationWidget) {
  
});


define("nmodule/honIrmConfig/rc/honIrmConfig.run", function(){});
